/* howfar() v0.0.16 19990215 19990606 19990808 */
static const char *version = "v0.0.16";
#define CREDIT	"howfar()"
#define CGI_CREDIT "keitai.cgi"
#define COPYRIGHT "(C)1998,1999 GOTO Naohisa"

#define CGI_LOGFILE	"keitai.log"

#ifdef CGI
	#undef CGI
	#define CGI	1
	#define CMDLINE	0
#else
	#define CGI	0
	#define CMDLINE	1
#endif /* CGI */

#if CGI
	#undef HTML
	#define HTML	1
#endif /* CGI */

#ifndef HTML
	#define HTML	0
#endif /* HTML */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "k_defs.h"
#include "keitai.h"
#include "cmnfnc.h"

#if CGI
	#include "cgi_com.h"
	#include "genfnc.h"
#endif /* CGI */

/* Хѿ */
static int time_printed = -1;

#define PADSPCS "  "

/* ץȥ */
static void select_intro(void);
void keit_print_main(long tm, int tm2, int eken, int hken, int tken,
int w, const char *cstr);
void keit_print_main2(long tm, int tm2, int hken, int tken,
int w, int ca);
/* ɽϲ */
static void print_plan(const char *p, int ca, int denpa, int plan);
static void print_charge(long *ch, int w);
static void print_ch(long c0, long c1, long c2, long c3);
static void print_tm(int x);
static void print_r4(long c0, long c1, long c2, long c3);
static void print_r2(long c0, long c1);
/* HTML */
#if HTML
static void html_start(char *);
static void html_end(void);
#endif

/* ¾ΥեƤؿ */
extern void keit_html_tbl_print_main(long tm, int tm2, int eken, int hken, 
int tken, int w, const char *cstr);
extern void keit_csv_print_main(long tm, int tm2, int eken, int hken, 
int tken, int w, const char *cstr);

/* ؿޥ */
#define checkrange_w(w) ((w < 1 || w > 3) ? 1 : 0)

int my_printf(const char *format, ...)
{
	int i;
	va_list arg;

	va_start(arg, format);
	i = vprintf(format, arg);
	/* sprintfˤϡvsprintf(buf, format, arg) ˤ롣*/
	va_end(arg);

	return i;
} /* end of func */

int stderr_printf(const char *format, ...)
{
	int i;
	va_list arg;

	va_start(arg, format);
	i = vfprintf(stderr, format, arg);
	va_end(arg);

	return i;
} /* end of func */

int main(int argc, char *argv[])
{
	long tm;
	int tm2;
	int eken, hken, tken, w;
	int chiiki;

	double f;
	int r;
	int err = 0;
	int output_format = 0;
	int print_kihon = 1;

#if CGI
	char *form;
	long min;
	int err1 = 0, err2 = 0;
#endif /* CGI */

#if CMDLINE
	my_printf(CREDIT " %s+keitai.lib %ld \n", version, k_version());
	my_printf(COPYRIGHT "\n");
#endif /* CMDLINE */

	/*  */
#if CMDLINE
	select_intro();

	chiiki = select_chiiki();
	eken = chiiki2eken(chiiki);

	show_todofuken();
	hken = select_num(1, 47, "ȯƻܸ? ") -1;

	show_todofuken();
	tken = select_num(1, 47, "ä򤫤ƻܸ? ") -1;

	w = select_num(1, 3, " "
		"1.̲ 2. 3.PHS (1-3)? ");

	f = inp_time();
	double2tm(f, &tm, &tm2);
#endif /* CMDLINE */

#if CGI
	cgi_initform(); /* եν */

	form = cgi_getform("chiiki");
	err += text2int(form, &chiiki, 0);
	chiiki -= 1;
	eken = chiiki2eken(chiiki);

	form = cgi_getform("hken");
	err += text2int(form, &hken, -1);
	hken -= 1;

	form = cgi_getform("tken");
	err += text2int(form, &tken, -1);
	tken -= 1;
	if (tken == -1) tken = hken; /* Ʊ츩 */

	form = cgi_getform("w");
	err += text2int(form, &w, -1);
	/* wϤΤޤ(ޥʥ1ʤ) */

	f = 0; /* ǰΤ */
	form = cgi_getform("tm");
	if (form == NULL) {
		err1 = 1;
	} else {
		r = sscanf(form, "%lf", &f);
		if (r != 1) err1 = 1;
	}
	double2tm(f, &tm, &tm2);

	form = cgi_getform("min");
	if (form == NULL) {
		err2 = 1;
	} else {
		r = sscanf(form, "%ld", &min);
		if (r != 1) err2 = 1;
	}
	if (err2 == 0) tm = tm + min * 60; /* ʬñ̤λ֤­ */
	if (err1 && err2) err = 1;

	form = cgi_getform("ot");
	err += text2int(form, &output_format, 1);

	form = cgi_getform("kh");
	err += text2int(form, &print_kihon, 1);

	/*  */
	cgi_accounting(CGI_LOGFILE);
#endif /* CGI */

	/*  */
	set_print_kihon(print_kihon);

	/* ϰϥå */
	r = checkrange_tm(tm, tm2)
		+ checkrange_ken(eken, hken, tken)
		+ checkrange_chiiki(chiiki)
		+ checkrange_w(w);

	if (r || err) {
#if HTML
		html_start("ERROR: out of range");
		my_printf(
			"<h1>顼 : ϰϳοͤǤ</h1>\n"
			);
		html_end();

#else /* HTML */
		my_printf("顼: ϰϳοͤǤ\n");
#endif /* HTML */

		return 1;
	}

	/* ɽ */
#if CMDLINE
	my_printf("\n");
#endif /* CMDLINE */
#if HTML
	html_start("result");
#endif /* HTML */

	switch(output_format) {
#if HTML
	case 1:
		keit_html_tbl_print_main(tm, tm2, eken, hken, tken, w, chiiki_str[chiiki]);
		break;
#endif /* HTML */
#if CGI
	case 2:
#if HTML
		my_printf("<pre>\n");
#endif /* HTML */
		keit_csv_print_main(tm, tm2, eken, hken, tken, w, chiiki_str[chiiki]);
#if HTML
		my_printf("\n");
		my_printf("</pre>");
#endif /* HTML */
		break;
#endif /* CGI */
	case 0:
	default:
#if HTML
		my_printf("<pre>");
#endif /* HTML */
		keit_print_main(tm, tm2, eken, hken, tken, w, chiiki_str[chiiki]);
#if HTML
		my_printf("\n");
		my_printf("</pre>");
#endif /* HTML */
		break;
	}

#if HTML
#if CGI
	my_printf("<hr>\n");
	my_printf(CGI_CREDIT " %s + keitai.lib %ld"
		, version, k_version());
	my_printf(" " COPYRIGHT "<br>\n");
#endif /* CGI */
	html_end();
#endif /* HTML */

	return 0;
} /* end of main */

#if CMDLINE
/*  ᥤ */
static void select_intro(void)
{
	stderr_printf("\n");
	stderr_printf("ꤷϰǱĶȤƤҤˤĤ"
		"Ӥޤ\n");
} /* end of func */
#endif /* CMDLINE */

/* ɽ ᥤ */
void keit_print_main(long tm, int tm2, int eken, int hken, int tken,
int w, const char *cstr)
{
	int i;
	long min, tmx;
	const int *clist;
	int ca;

	time_printed = -1; /* ɬӶʬɽ */
	clist = ls_carrier_ken(eken);

	/* ǽηޤʸɽ */

	my_printf("%sǱĶȤƤ\n", cstr);

	for (i=0; clist[i] >= 0 ; i++) {
		my_printf("        %s\n", nameof_carrier(clist[i]));
	}
	my_printf("ˤĤơ");
	my_printf("%s%s%sؤ",
		nameof_pref(hken), nameof_pref(tken), wstr[w]);

	min = tm / 60;
	tmx = tm - min * 60;
	if (min >= 1) my_printf("%ldʬ", min);
	if (tmx + tm2 > 0) my_printf("%ld%s", tmx, tm2 ? ".5" : "");
	if (min >= 1) my_printf("(%ld%s)", tm, tm2 ? ".5" : "");
	my_printf("֤\nɽޤ(ñ:)\n");

	my_printf("\n");
	my_printf("ä˻꤬ʤ硢ʿ֤ʿ8:00-19:00, "
			"ʿ֤ʿ19:00-23:00,\n"
			"ˡ֤(8:00-23:00), "
			"23:00-8:00\n"
			"ؤޤ\n");

	/* ᥤξɽ */
	for (i=0; ; i++) {
		ca = clist[i];
		if (ca < 0) break;
		keit_print_main2(tm, tm2, hken, tken, w, ca);
	}

	/* Ǹηޤʸɽ */
	my_printf("\n");
	print_notice_txt();

	return;
} /* end of print_main() */

void keit_print_main2(long tm, int tm2, int hken, int tken,
int w, int ca)
{
	int j, k, r;
	int roam_c, ca2;
	const int *dlist;
	const int *rlist;
	const char **plist;
	long *ch;

	r = -1;
	rlist = roaming_carrier(ca, hken);
	do {
		r++;
		my_printf("\n");
		roam_c = rlist[r];
		time_printed = -1; /* ɬӤɽ */
		my_printf("%s", nameof_carrier(ca));
		if (roam_c >= 0) {
			dlist = ls_system_roaming(ca, roam_c);
			my_printf(" : %s˥ߥ\n", nameof_carrier(roam_c));
		} else {
			dlist = ls_system(ca);
			ca2 = carrier_group_ken(groupof_carrier(ca), hken);
			if (ca != ca2) {
				my_printf(" ( -> %s)\n", nameof_carrier(ca2));
			} else {
				my_printf("\n");
			}
		} /* if (roam_c) */
		for (j=0; dlist[j] >= 0; j++) {
			my_printf(" < %s >\n", nameof_system(dlist[j]));
			plist = ls_plan(ca, dlist[j]);
			if (plist == NULL) {
				my_printf("        (ǡ۾)\n");
			} else {
				for (k=0; plist[k] != NULL; k++) {
					ch = calc_charge(tm, tm2, hken, tken, ca, 
						dlist[j], k, roam_c);
					if (ch[0] == 1) {
						my_printf(PADSPCS "ĶȥꥢǤ\n");
						break; /* for */
					}
					print_plan(plist[k], ca, dlist[j], k);
					print_charge(ch, w);
				} /* for(k) */
			} /* if(plist) */
		} /* for(j) */
	} while (roam_c >= 0 && rlist[r+1] >= 0);

	return;
} /* end of print_main2() */

/* ɽϤδؿ  */
static void print_charge(long *ch, int w)
{
	print_tm(ch[4]);

	switch(w) {
	case 1: /* ̲ */
		if (ch[1] & 0x8) { /* ɥ̳ƻΥ¸ */
			print_ch(ch[32], ch[33], ch[34], ch[35]);
			my_printf(" Υ\n");
			print_ch(ch[8], ch[9], ch[10], ch[11]);
			my_printf(" ʳ\n");
		} else {
			print_ch(ch[8], ch[9], ch[10], ch[11]);
			my_printf("\n");
		}
		break;
	case 2: /*  */
		if (ch[2] >= 0) {
			print_ch(ch[12], ch[13], ch[14], ch[15]);
			my_printf(" %sη\n", nameof_group(ch[2]));
			print_ch(ch[16], ch[17], ch[18], ch[19]);
			my_printf(" ʳ\n");
		} else {
			print_ch(ch[16], ch[17], ch[18], ch[19]);
			my_printf("\n");
		}
		break;
	case 3: /* PHS */
		if ((ch[1] & 0x1)== 1) {
			print_ch(ch[20], ch[21], ch[22], ch[23]);
			my_printf(" ¸PHS\n");
			print_ch(ch[24], ch[25], ch[26], ch[27]);
			my_printf(" ȼPHS\n");
		} else {
			print_ch(ch[20], ch[21], ch[22], ch[23]);
			my_printf("\n");
		}
		break;
	} /* switch(w) */

	if ((ch[1] & 0x4) != 0) { /* ̵ʬ˴ޤޤʤ */
		my_printf(PADSPCS "*ϡ"
				"ܻߤ̵ʬ˴ޤޤޤ\n");
	}

	if (ch[3] != 0) { /* ۴(IDO顼Υɥߥ) */
		my_printf(PADSPCS "*۴%ldߤɬס\n", ch[3]);
	}

	return;
} /* end of thid func */

static void print_plan(const char *p, int ca, int denpa, int plan)
{
	const int *a;

	a = getinfo_plan(ca, denpa, plan);

	my_printf("%-28s", p);

	if (is_print_kihon()) {
		my_printf("  ܻ %d", a[0]);
		if (a[1] > 0) my_printf("  %dʬ", a[1]);
	}

	my_printf("\n");
	return;
} /* end of func */

static void print_tm(int x)
{
	static const char *tmstr[] = {
	/* ɸ */
		"  [ʿ][ʿ]    []    []\n",
	/* TIME_N1 */
		"  [ʿ8:00 [ʿ17:00 [8:00 [19:00\n"
		"     -17:00]    -19:00]   -19:00]     -8:00]\n",
	/* TIME_N2 */
		"  [ӥͥ]            [ޥ]\n"
		"(ʿ9:00-11:30,13:30-17:00)   (ʳ)\n",
	/* TIME_N3 */
		"  [ʿ8:00-11:30,13:30-23:00]  [ʳ]\n",
	/* TIME_N4 */
		"  [ʿ7:00 [7:00 [21:00 [0:00\n"
		"     -21:00]   -21:00]     -0:00]    -7:00]\n",
	/* TIME_N5 */
		"  [8:00-22:00]          [22:00-8:00]\n",
	/* TIME_N6 */
		"  [ʿ9:00-17:00]          [ʳ]\n",
	/* TIME_N7 */
		"  [ʿ8:00-11:30 [ʿ [8:00[23:00\n"
		"  13:30-23:00] 11:30-13:30]  -23:00] -8:00]\n",
	/* TIME_N8 */
		"  [8:00-20:00]          [20:00-8:00]\n",
	/* TIME_N9 */
		"  [8:00-17:00]          [17:00-8:00]\n",
	/* ñʤߡ */
		NULL
	};

	if (time_printed == x) return;

	my_printf("%s", tmstr[x]);
	time_printed = x;
	return;
} /* end of func */

static void print_r4(long c0, long c1, long c2, long c3)
{
	my_printf(PADSPCS "%9ld %9ld %9ld %9ld",
				c0, c1, c2, c3);

	return;
} /* end of func */

static void print_r2(long c0, long c1)
{
	my_printf(PADSPCS "%9ld                     %9ld",
				c0, c1);
	return;
} /* end of func */

static void print_ch(long c0, long c1, long c2, long c3)
{
	switch(time_printed) {
	case TIME_STD:
	case TIME_N1:
		print_r4(c0, c1, c2, c3);
		break;
	case TIME_N2:
		print_r2(c0, c1);
		break;
	case TIME_N3:
		print_r2(c0, c2);
		break;
	case TIME_N4:
		print_r4(c0, c2, c1, c3);
		break;
	case TIME_N5:
	case TIME_N8:
	case TIME_N9:
		print_r2(c0, c3);
		break;
	case TIME_N6:
		print_r2(c0, c1);
		break;
	case TIME_N7:
		print_r4(c0, c1, c2, c3);
		break;
	}

	return;
} /* end of func */

#if HTML
/* HTMLؿ */
static void html_start(char *title)
{
#if CGI
	my_printf("Content-type: text/html\n");
	my_printf("\n");
#endif /* CGI */

	my_printf("<html><head>\n");
	my_printf("<title>%s</title>\n", title);
	my_printf("</head>\n");

	my_printf("<body bgcolor=\"a0c0e8\">\n");
	return;
} /* end of func */
static void html_end(void)
{
	my_printf("</body>\n");
	my_printf("</html>\n");
	return;
} /* end of func */
#endif /* HTML */
