/* docomo.c 19990711 19991206 20000702 */
const long docomo_revision=20000702;
/* 19990401	ʥHICAPѻ */

#include <stdio.h>
#include "k_defs.h"
#include "keitai.h"
#include "k_priv.h"

/* ץȥ */
static void nt_calc(long tm, int tm2, long *r, short *ntc, 
float *dummy0, int *dummy1);
static void std_calc(long tm, int tm2, long *r, short *dummy0,
float *stdt, int *px);

/* ܸΥǡ */
static const int do_rinsetu[][11] = /* ܸ */
{
		/* "NTTɥ̳ƻ" */
		 {aomori, -1},
		/* "NTTɥ" */
		{hokkaido, niigata, ibaraki, tochigi, gunma, -1},
		/* "NTTɥ" */
		{yamagata, fukusima, toyama, gifu, aichi,
		 sizuoka, -1},
		/* "NTTɥΦ" */
		{gifu, kyoto, siga, niigata, nagano, -1},
		/* "NTTɥ쳤" */
		{kanagawa, yamanasi, nagano, toyama, isikawa,
		 fukui, kyoto, siga, nara, wakayama, -1},
		/* "NTTɥ" */
		{mie, gifu, fukui, tottori, okayama, kagawa,
		 tokusima, -1},
		/* "NTTɥ" */
		/* ɥ??ܸüʰˤʤ */
		{-1 },
		/* "NTTɥ͹" */
		{wakayama, osaka, hyogo, okayama, hirosima,
		 yamaguchi, oita, miyazaki, -1},
		/* "NTTɥ彣" */
		{yamaguchi, ehime, -1}
};

/* ɥܸ */
static const int do7_rinsetu[][6] = {
/* ȯ ܸ... -1 */
/* Ļ	*/	{ tottori, hyogo, -1 },
/*  */	{ okayama, hyogo, tokusima, ehime, kagawa, -1 },
/* 纬 */	{ simane, -1 },
/*  */	{ hirosima, ehime, kagawa, -1 },
/*  */	{ yamaguchi, ehime, oita, fukuoka, -1 },
			{ -1, -1 }
};

/* ץΥǡ */
static const char *do_pdc8_p[] = {
	"ץA",
	"ץB",
	"Ϥʤץ饹BIG",
#define OHA_BIG 2
	"Ϥʤץ饹L",
#define OHA_L 3
	"Ϥʤץ饹M",
#define OHA_M 4
	"Ĺץ",
	NULL
};

static const char *do9_pdc8_p[] = {
/* ɥ彣Τ߰ۤʤ */
	"١åץ(ץA)",
	"ѡʥץ(ץB)",
	"Ϥʤץ饹BIG",
	"Ϥʤץ饹L",
	"Ϥʤץ饹M",
	"Ĺץ", /* 彣ˤĹץ¸ߤʤ??? Ȼפä¸ߤߤѶŪƤʤ??? */
	NULL
};

static int do_pdc8_px[][5] = {
	/* ݶ, (ݶñ)ʿ, ʿ, ,  */
	0, 10, 10, 10, 10, /* ץA */
	0, 14, 14, 14, 14, /* ץB */
	0, 11, 11, 11, 11, /* Ϥʤץ饹BIG */
	0, 12, 12, 12, 12, /* Ϥʤץ饹L */
	0, 14, 14, 14, 14, /* Ϥʤץ饹M */
	1, -2, -2, -2, -2, /* Ĺץ */
};

static int do_pdc8_info[][6][2] = {
	/* DO1: */
	4500, 200,	/* ץA */
	3500, 400,	/* ץB */
	9100, 6300,	/* Ϥʤץ饹BIG */
	5500, 2700,	/* Ϥʤץ饹L */
	3900, 1100,	/* Ϥʤץ饹M */
	4500, 200,	/* Ĺץ */
	/* DO2: */
	4500, 200,	/* ץA */
	3500, 400,	/* ץB */
	9000, 6200,	/* Ϥʤץ饹BIG */
	5600, 2800,	/* Ϥʤץ饹L */
	3900, 1100,	/* Ϥʤץ饹M */
	4500, 200,	/* Ĺץ */
	/* DO3: */
	4500, 200,	/* ץA */
	3500, 400,	/* ץB */
	9100, 6300,	/* Ϥʤץ饹BIG */
	5900, 3100,	/* Ϥʤץ饹L */
	4100, 1300,	/* Ϥʤץ饹M */
	4500, 200,	/* Ĺץ */
	/* DO4: */
	4500, 200,	/* ץA */
	3500, 400,	/* ץB */
	9100, 6300,	/* Ϥʤץ饹BIG */
	5900, 3100,	/* Ϥʤץ饹L */
	4100, 1300,	/* Ϥʤץ饹M */
	4500, 200,	/* Ĺץ */
	/* DO5: */
	4500, 200,	/* ץA */
	3500, 400,	/* ץB */
	9100, 6300,	/* Ϥʤץ饹BIG 2611, PHSü */
	5300, 2500,	/* Ϥʤץ饹L */
	3600, 800,	/* Ϥʤץ饹M */
	4500, 200,	/* Ĺץ */
	/* DO6: */
	4500, 200,	/* ץA */
	3500, 400,	/* ץB */
	8800, 6000,	/* Ϥʤץ饹BIG */
	5200, 2400,	/* Ϥʤץ饹L */
	3900, 1100,	/* Ϥʤץ饹M */
	4500, 200,	/* Ĺץ */
	/* DO7: */
	4500, 200,	/* ץA */
	3500, 400,	/* ץB */
	9100, 6300,	/* Ϥʤץ饹BIG */
	5900, 3100,	/* Ϥʤץ饹L */
	3900, 1100,	/* Ϥʤץ饹M */
	4500, 200,	/* Ĺץ */
	/* DO8: ??? */
	4500, 200,	/* ץA */
	3500, 400,	/* ץB */
	9100, 6300,	/* Ϥʤץ饹BIG 2611, PHS1.1 */
	5900, 3100,	/* Ϥʤץ饹L */
	3800, 1000,	/* Ϥʤץ饹M */
	4500, 200,	/* Ĺץ */
	/* DO9: ??? */
	4500, 200,	/* ץA */
	3500, 400,	/* ץB */
	9100, 6300,	/* Ϥʤץ饹BIG */
	5500, 2700,	/* Ϥʤץ饹L */
	3900, 1100,	/* Ϥʤץ饹M */
	4500, 200,	/* Ĺץ */
};

static const char *do_pdc15_p[] = {
	"ץA",
	"ץC",
	"ץD",
	"Ϥʤץ饹S",
	"Ĺץ",
	NULL
};

static int do_pdc15_px[][5] = {
	/* ݶ, (ݶñ)ʿ, ʿ, ,  */
	0, 10, 10, 10, 10,	/* ץA */
	0, 15, 10, 10, 10,	/* ץC */
	0, 15, 15, 15, 15,	/* ץD */
	0, 20, 20, 20, 20, 	/* Ϥʤץ饹S */
	1, -2, -2, -2, -2	/* Ĺץ */
};

static const int do_pdc15_info[][2] = {
	3400, 0,	/* ץA */
	2700, 0,	/* ץC */
	2500, 0,	/* ץD */
	2900, 1300,	/* Ϥʤץ饹S */
	3400, 0 	/* Ĺץ */
};

/* ǡ */
static float std_time_p8[][6][4] = {
/*̳ƻDO1: */
/*	ʿ  ʿ     */
	/* PDC8 */
	21.0,	26.0,	29.0,	40.0, /* Ʊƻܸ(̳ƻϡֶΥ) */
	21.0,   26.0,	29.0,	40.0, /* Ķȶ⡦ܸ */
	19.5,	24.0,	27.0,	38.0, /* ¾ */
	14.5,	23.5,	26.5,	36.5,   /* ɥ⤫ɥ */
	12.5,	20.5,	22.5,   31.5,   /* ӡư */
	17.0,   19.5,	19.5,	19.5, /* Уȣ */

/*̡DO2: */
	23.5,	30.5,	34.5,	47.5,
	23.5,	30.5,	34.5,	47.5,
	19.5,	24.0,	27.0,	28.0,
	16.5,	26.5,	30.0,	41.5,
	14.5,	23.5,	26.5,	36.5,
	20.0,	21.0,	21.0,	21.0,
/* DO3: */
	23.5,	30.5,	34.5,	47.5,
	23.5,   30.5,   34.5,	47.5,
	19.5,   24.0,	27.0,   38.0,
	16.5,   26.5,	30.0,   41.5,
	14.5,   23.5,	26.5,	36.5,
	20.0,   21.0,   21.0,   21.0,
/* ΦDO4: */
	24.5,   32.5,   36.5,	50.0,
	24.5,   32.5,	36.5,   50.0,
	19.5,   24.0,	27.0,   38.0,
	18.0,   29.0,	32.5,   45.0,
	16.0,   26.0,   29.0,	40.0,
	20.0,   21.0,   21.0,   21.0,
/* 쳤DO5: */
	23.5,	30.5,	34.5,	47.5,
	23.5,	30.5,	34.5,	47.5,
	19.5,   24.0,	27.0,   38.0,
	16.5,   26.5,	30.0,   41.5,
	14.5,   23.5,	26.5,	36.5,
	20.0,   21.0,   21.0,   21.0,
/* ʴDO6: */
	23.5,	32.5,	36.5,	50.0,
	23.5,	32.5,	36.5,	50.0,
	19.5,	24.0,	27.0,	38.0,
	18.0,	29.0,	32.5,	45.0,
	16.0,	26.0,	29.0,	40.0,
	20.0,	21.0,	21.0,	21.0,
/* DO7: */
	24.5,   30.5,	34.5,   47.5,
	24.5,   30.5,	34.5,   47.5,
	19.5,   24.0,	27.0,   38.0,
	17.0,   27.5,	31.0,   42.5,
	15.5,	26.0,   28.0,	39.0,
	20.0,   21.0,   21.0,   21.0,
/* ʻ͹DO8: */
	24.5,	32.5,	36.5,	50.0,
	24.5,	32.5,	36.5,	50.0,
	19.5,	24.0,	27.0,	38.0,
	17.5,	28.5,	32.0,	44.0,
	15.5,	26.0,	28.0,	39.0,
	20.0,	21.0,	21.0,	21.0,
/* ʶ彣DO9: */
	24.5,	32.5,	36.5,	50.0,
	24.5,	32.5,	36.5,	50.0,
	19.5,	24.0,	27.0,	38.0,
	18.0,	29.0,	32.5,	45.0,
	16.0,	26.0,	29.0,	40.0,
	20.0,	21.0,	21.0,	21.0,
};

static float std_time_p15[][6][4] = {
/* ̳ƻ DO1: */
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
/*  DO2: */
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
/*  DO3: */
	26.0,	43.5,	47.5,	65.0,
	26.0,	43.5,	47.5,	65.0,
	19.5,	24.0,	27.0,	38.0,
	25.0,	41.5,	45.5,	62.5,
	20.0,	37.0,	37.0,	51.5,
	20.0,	21.0,	21.0,	21.0,
/* Φ DO4: */
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
/* 쳤 DO5: */
	26.0,	43.5,	47.5,	65.0,
	26.0,	43.5,	47.5,	65.0,
	19.5,	24.0,	27.0,	38.0,
	25.0,	41.5,	45.5,	62.5,
	20.0,	37.0,	37.0,	51.5,
	20.0,	21.0,	21.0,	21.0,
/*  DO6: */
	26.0,	43.5,	47.5,	65.0,
	26.0,	43.5,	47.5,	65.0,
	19.5,	24.0,	27.0,	38.0,
	25.0,	41.5,	45.5,	62.5,
	20.0,	37.0,	37.0,	51.5,
	20.0,	21.0,	21.0,	21.0,
/*  DO7: */
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
/* ͹ DO8: */
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
/* 彣 DO9: */
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1,
	-1,	-1,	-1,	-1
};

static short nt_charge_p15[][6][3][4] = { /* Ĺץ (/ʬ) */
/* 1.5GHz PDC */
/* ̳ƻ DO1: */
	-1, 	-1, 	-1, 	-1, /* ӥ¸ߤʤΤ-1 */
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
/*  DO2: */
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
/*  DO3: */
/*	ʿ	ʿ		 */
/* Ʊƻܸ */
	25, 	15, 	15, 	10, /* ʬ */
	20, 	10, 	10, 	 9, /* ʬ */
	15, 	10, 	10, 	 7, /* ʹߣʬ */
/* Ķȶ⡦ܸ */
	25, 	15, 	15, 	10,
	20, 	10, 	10, 	9,
	15, 	10, 	10, 	7,
/* ¾ */
	32, 	28, 	25, 	18,
	28, 	24, 	22, 	16,
	23, 	17, 	15, 	11,
/* ɥ⤫ɥ */
	30, 	20, 	15, 	10,
	20,	10, 	10, 	9,
	15, 	10, 	10, 	7,
/* ӡư */
	30, 	20, 	15, 	10,
	20,	10, 	10, 	10,
	20, 	10, 	10, 	10,
/* Уȣ */
	29, 	29, 	29, 	29,
	27, 	25, 	25, 	25,
	24, 	23, 	23, 	23,
/* Φ DO4: */
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
/* 쳤 DO5: */
/*	ʿ	ʿ		 */
/* Ʊƻܸ */
	25, 	15, 	15, 	10, /* ʬ */
	20, 	10, 	10, 	 9, /* ʬ */
	15, 	10, 	 9, 	 7, /* ʹߣʬ */
/* Ķȶ⡦ܸ */
	25, 	15, 	15, 	10,
	20, 	10, 	10, 	 9,
	15, 	10, 	 9, 	 7,
/* ¾ */
	34, 	27, 	25, 	17,
	28, 	23, 	21, 	15,
	22, 	17, 	15, 	12,
/* ɥ⤫ɥ */
	30, 	18, 	15, 	10,
	20,	10, 	10, 	 9,
	15, 	10, 	 9, 	 7,
/* ӡư */
	30, 	20, 	15, 	10,
	20,	10, 	10, 	10,
	20, 	10, 	10, 	 9,
/* Уȣ */
	30, 	29, 	29, 	29,
	26, 	25, 	25, 	25,
	22, 	22, 	22, 	22,
/*  DO6: */
/*	ʿ	ʿ		 */
/* Ʊƻܸ */
	20, 	13, 	13, 	10, /* ʬ */
	19, 	10, 	10, 	8,  /* ʬ */
	18, 	10, 	10, 	8, /* ʹߣʬ */
/* Ķȶ⡦ܸ */
	20, 	13, 	13, 	10, /* ʬ */
	19, 	10, 	10, 	8,  /* ʬ */
	18, 	10, 	10, 	8, /* ʹߣʬ */
/* ¾ */
	28, 	20, 	18, 	14,
	26, 	20, 	18, 	12,
	24, 	20, 	18, 	12,
/* ɥ⤫ɥ */
	20, 	14, 	13, 	10,
	20, 	10, 	10, 	10,
	20, 	10, 	10, 	10,
/* ӡư */
	25, 	15, 	15, 	10,
	25, 	15, 	10, 	10,
	25, 	15, 	10, 	10,
/* Уȣ */
	25, 	24, 	24, 	24,
	25, 	24, 	24, 	24,
	25, 	24, 	24, 	24,
/*  DO7: */
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
/* ͹ DO8: */
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
/* 彣 DO9: */
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1,
	-1, 	-1, 	-1, 	-1
};

static short nt_charge_p8[][6][3][4] = { /* Ĺץ (/ʬ) */
/* 800MHz PDC */
/* ̳ƻ DO1: (http) */
	29,	24,	19,	14,	/* Υ Ϥ1ʬ */
	25,	19,	19,	14,	/*        1ʬ */
	20,	19,	14,	9 ,	/*        ʹ */
	29,	24,	19,	14,	/* ⡦ */
	25,	19,	19,	14,
	20,	19,	14,	 9,
	30,	26,	21,	16,	/* ¾ */
	28,	21,	21,	16,
	25,	21,	16,	11,
	48,	30,	29,	19,	/* ܥɥ */
	39,	25,	19,	15,
	24,	15,	15,	10,
	50,	30,	30,	20,	/*  */
	45,	25,	22,	17,
	28,	17,	15,	10,
	35,	33,	33,	33, /* PHS */
	33,	30,	30,	30,
	29,	24,	24,	24,
/*  DO2: */
/*	ʿ	ʿ		 */
/* Ʊƻܸ */
	29,	22,	20,	14,
	24,	19,	17,	12,
	17,	14,	12,	 9,
/* Ķȶ⡦ܸ */
	29,	22,	20,	14,
	24,	19,	17,	12,
	17,	14,	12,	 9,
/* ¾ */
	33,	28,	24,	17,
	28,	23,	20,	15,
	23,	18,	16,	12,
/* ɥ⤫ɥ */
	39,	24,	20,	15,
	34,	20,	19,	14,
	29,	18,	15,	10,
/* ӡư */
	39,	24,	20,	15,
	34,	20,	19,	14,
	34,	20,	19,	14,
/* Уȣ */
	30,	29,	29,	29,
	27,	25,	25,	25,
	23,	23,	23,	23,
/*  DO3: */
/*	ʿ	ʿ		 */
/* Ʊƻܸ */
	29, 	22, 	20, 	14, /* ʬ */
	24, 	19, 	17, 	12, /* ʬ */
	17, 	14, 	12, 	9 , /* ʹߣʬ */
/* Ķȶ⡦ܸ */
	29, 	22, 	20, 	14, /* ʬ */
	24, 	19, 	17, 	12, /* ʬ */
	17, 	14, 	12, 	9 , /* ʹߣʬ */
/* ¾ */
	32, 	28, 	25, 	18,
	28, 	24, 	22, 	16,
	23, 	17, 	15, 	11,
/* ɥ⤫ɥ */
	40, 	25,  	20, 	15,
	35, 	20, 	20, 	14,
	25, 	16, 	14, 	10,
/* ӡư */
	40, 	25,  	20, 	15,
	35, 	20, 	20, 	15,
	30, 	19, 	16, 	12,
/* Уȣ */
	29, 	29, 	29, 	29,
	27, 	25, 	25, 	25,
	24, 	23, 	23, 	23,
/* Φ DO4: (http) */
/* Ʊƻܸ */
	28,	20,	17,	12,
	21,	15,	15,	10,
	17,	10,	10,	 8,
/* Ķȶ⡦ܸ */
	28,	20,	17,	12,
	21,	15,	15,	10,
	17,	10,	10,	 8,
/* ¾ */
	35,	25,	25,	20,
	30,	20,	20,	15,
	25,	15,	15,	10,
/* ɥ⤫ɥ */
	40,	25,	20,	15,
	30,	20,	17,	12,
	20,	13,	11,	 8,
/* ӡư */
	40,	25,	20,	15,
	35,	20,	19,	14,
	25,	16,	13,	10,
/* Уȣ */
	30,	25,	25,	25,
	30,	25,	25,	25,
	25,	20,	20,	20,
/* 쳤 DO5: */
/*	ʿ	ʿ		 */
/* Ʊƻܸ */
	29, 	22, 	20, 	14, /* ʬ */
	23, 	19, 	16, 	12, /* ʬ */
	18, 	13, 	12, 	9, /* ʹߣʬ */
/* Ķȶ⡦ܸ */
	29, 	22, 	20, 	14,
	23, 	19, 	16, 	12,
	18, 	13, 	12, 	 9,
/* ¾ */
	34, 	27, 	25, 	17,
	28, 	23, 	21, 	15,
	22, 	17, 	15, 	12,
/* ɥ⤫ɥ */
	39, 	25, 	20, 	15,
	35, 	20, 	20, 	14,
	25, 	16, 	14, 	10,
/* ӡư */
	40, 	25, 	20, 	15,
	35, 	20, 	20, 	15,
	31, 	19, 	16, 	12,
/* Уȣ */
	30, 	29, 	29, 	29,
	26, 	25, 	25, 	25,
	22, 	22, 	22, 	22,
/*  DO6: */ 
/*	ʿ	ʿ		 */
/* Ʊƻܸ */
	22, 	13, 	13, 	13, /* ʬ */
	20, 	13, 	13, 	 8, /* ʬ */
	18, 	13, 	13, 	 8, /* ʹߣʬ */
/* Ķȶ⡦ܸ */
	22, 	13, 	13, 	13, /* ʬ */
	20, 	13, 	13, 	 8, /* ʬ */
	18, 	13, 	13, 	 8, /* ʹߣʬ */
/* ¾ */
	28, 	20, 	18, 	14,
	26, 	20, 	18, 	12,
	24, 	20, 	18, 	12,
/* ɥ⤫ɥ */
	28, 	14, 	13, 	14,
	28, 	14, 	13, 	 9,
	23, 	14, 	13, 	 9,
/* ӡư */
	28, 	19, 	19, 	14,
	28, 	19, 	19, 	 9,
	28, 	19, 	14, 	 9,
/* Уȣ */
	25, 	24, 	24, 	24,
	25, 	24, 	24, 	24,
	25, 	24, 	24, 	24,
/*  DO7: (http) */
/* Ʊƻܸ */
	29,	23,	20,	15,
	24,	20,	17,	13,
	18,	14,	13,	9,
/* Ķȶ⡦ܸ */
	29,	23,	20,	15,
	24,	20,	17,	13,
	18,	14,	13,	9,
/* ¾ */
	36,	27,	24,	17,
	31,	24,	21,	15,
	23,	18,	16,	11,
/* ɥ⤫ɥ */
	40,	25,	22,	16,
	34,	15,	19,	14,
	24,	14,	13,	10,
/* ӡư */
	40,	25,	22,	16,
	35,	20,	19,	14,
	29,	15,	15,	10,
/* Уȣ */
	33,	30,	30,	30,
	30,	28,	28,	28,
	24,	23,	23,	23,
/* ͹ DO8: */
/* Ʊƻܸ */
	23,	20,	16,	12,
	23,	20,	14,	10,
	18,	15,	11,	10,
/* Ķȶ⡦ܸ */
	23,	20,	16,	12, /* ٤Ʊ츩Ʊ */
	23,	20,	14,	10,
	18,	15,	11,	10,
/* ¾ */
	30,	21,	21,	15,
	27,	21,	18,	13,
	23,	17,	16,	12,
/* ɥ⤫ɥ */
	30,	20,	20,	15,
	30,	20,	20,	15,
	25,	15,	15,	10,
/* ӡư */
	35,	25,	25,	20,
	35,	25,	25,	15,
	30,	20,	15,	15,
/* Уȣ */
	30,	30,	30,	30,
	27,	25,	25,	25,
	23,	20,	20,	20,
/* 彣 DO9: */
/* 桼ȼwebڡ(http://www.oriental.or.jp/az/ryokin.html)
ƤǶϸȤˤǺܤ褦ˤʤäΤ */
/* Ʊƻܸ */
	30,	23,	18,	14,
	27,	18,	18,	14,
	18,	10,	10,	 9,
/* Ķȶ⡦ܸ */
	30,	23,	18,	14,
	27,	18,	18,	14,
	18,	10,	10,	9,
/* ¾ */
	35,	26,	26,	19,
	32,	26,	23,	15,
	24,	19,	15,	12,
/* ɥ⤫ɥ */
	38,	24,	19,	15,
	34,	19,	19,	15,
	24,	15,	15,	10,
/* ӡư */
	38,	24,	19,	15,
	33,	19,	19,	15,
	33,	19,	19,	15,
/* Уȣ */
	31,	29,	29,	29,
	29,	25,	25,	25,
	25,	23,	23,	23,
};

/* DO5, DO8 ΤϤʤץ饹{L, M, BIG}к */
/* DO5ΤϤʤץ饹L,M, BIGPHSΤ10ñ̤βݶäȻפä
   Ĥδ֤ˤDO8ƱˤʤäƤ餷 */
#if 0
static float std_time_oha_do5[][6][4] =
{
/* DO5 Ϥʤץ饹BIG */
/*	ʿ  ʿ     */
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	15,	19,	19,	19, /* 10ߤÿ */
/* DO5 Ϥʤץ饹L */
/*	ʿ  ʿ     */
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	12,	16,	16,	16, /* 10ߤÿ */
/* DO5 Ϥʤץ饹M */
/*	ʿ  ʿ     */
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	11,	14,	14,	14, /* 10ߤÿ */
};

static int do5_oha_phs_px[5] = {
	/* ݶ, (ݶñ)ʿ, ʿ, ,  */
	/* DO5ΤϤʤץ饹L,M, BIGPHSΤ10ñ̤βݶ */
	0, 10, 10, 10, 10
};
#endif

static float std_time_oha_do8[6][4] =
{
/* DO8 DO5 Ϥʤץ饹M,L, BIG */
/*	ʿ  ʿ     */
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	27.0,	27.0,	27.0,	27.0,
	20.0,   21.0,   21.0,   21.0, /* ɸƱ */
};

/* ؿ */
const char **docomo_ls_plan(int i, int d)
{

	switch(d) {
		case PDC8:
			if (i == DO9) return &(do9_pdc8_p[0]); /* 彣 */
			return &(do_pdc8_p[0]); /* ʳ */
			break;
		case PDC15:
			if (i == DO3 || i == DO5 || i == DO6)
				return &(do_pdc15_p[0]);
			break;
	}

	return NULL;

} /* end of this func */

const int *docomo_getinfo_plan(int i, int d, int plan)
{

	switch(d) {
		case PDC8:
			return &(do_pdc8_info[i][plan][0]);
			break;
		case PDC15:
			if (i == DO3 || i == DO5 || i == DO6)
				return &(do_pdc15_info[plan][0]);
			break;
	}

	return NULL;
} /* end of this func */

void docomo_calc_charge(long *result, long tm, int tm2, int h_ken,
int t_ken, int ca, int denpa, int plan, int roam_c)
{
	int h; /* ȯΥɥ */
	int r_ar = 0; /* or */
	int *px = NULL;
	float *stdt = NULL;
	short *ntc = NULL;
	void (*calc_r)(long, int, long *, short *, float *, int *);
	const int *rin_tbl;

	/*  */
	const int *p;
	int j, k;

	p = ls_carrier_ken(h_ken);
	do {
		h = *p++;
	} while (groupof_carrier(h) != DOCOMO);
	/*  h ȯΥɥˤʤ */

	p = ls_system(h);
	do {
		j = *p++;
		if (j < 0) {
			result[0] = 1; /* ȷϱĶȤƤʤ */
			result[7] = 0;
			return;
		}
	} while (j != denpa);

	/* ɥܸк */
	rin_tbl = &(do_rinsetu[h][0]);
	if (h == DO7) {
		for (j = 0; (k = do7_rinsetu[j][0]) != -1; j++) {
			if (k == h_ken) {
				rin_tbl = &(do7_rinsetu[j][1]);
				break;
			}
		} /* for */
	} /* if */
	r_ar = is_kuikinai_rinsetu(h, t_ken, rin_tbl);

	result[1] = 0;   /* ե饰 */
	result[7] = 16;  /* Ŀ */

	switch (denpa) {
		case PDC8:
			px = &(do_pdc8_px[plan][0]);
			stdt = &(std_time_p8[h][0][0]);
			ntc = &(nt_charge_p8[h][0][0][0]);
			if (plan == OHA_L || plan == OHA_M || plan == OHA_BIG) {
				switch (h) {
				/* DO5DO8ΤϤʤץ饹L,M, BIG ü */
				/* case DO5: */
				  /* stdt = &(std_time_oha_do5[plan - OHA_BIG][0][0]); */
				  /* break; */
				case DO5:
				case DO8:
					stdt = &(std_time_oha_do8[0][0]);
					break;
				default:
					break;
				}
			} /* if (plan) */
			break;
		case PDC15:
			px = &(do_pdc15_px[plan][0]);
			stdt = &(std_time_p15[h][0][0]);
			ntc = &(nt_charge_p15[h][0][0][0]);
			break;
	}

	if (px[0] == 1) { /* Ĺץ */
		calc_r = nt_calc;
	} else { /* ¾Υץ */
		calc_r = std_calc;
	}

	/* ޤPHS򥻥å */
#if 0
	if (h == DO5 && (plan == OHA_L || plan == OHA_M || plan == OHA_BIG)) {
	/* DO5ΤϤʤץ饹L,MPHSΤ10ñ */
		calc_r(tm, tm2, &(result[20]), &(ntc[60]), &(stdt[20]), do5_oha_phs_px);
	} else {
#endif
		calc_r(tm, tm2, &(result[20]), &(ntc[60]), &(stdt[20]), px);
#if 0
	}
#endif

	/* ̲ø */
	if (h_ken == t_ken) { /* Ʊƻܸ */
		if (h == DO1) { /* ɥ̳ƻζΥ¸ */
			calc_r(tm, tm2, &(result[8]), &(ntc[12]), &(stdt[4]), px);
			calc_r(tm, tm2, &(result[32]), &(ntc[0]), &(stdt[0]), px); /* Υ */
			result[1] |= 0x8; /* ե饰å */
			result[7] = 28;
		} else {
			calc_r(tm, tm2, &(result[8]), &(ntc[0]), &(stdt[0]), px);
		}
	} else if (r_ar > 0) { /* ⡦ */
		calc_r(tm, tm2, &(result[8]), &(ntc[12]), &(stdt[4]), px);
	} else { /* ¾θ */
		calc_r(tm, tm2, &(result[8]), &(ntc[24]), &(stdt[8]), px);
	}

	/* ɥ⤫ɥ */
	if (r_ar > 0) { /* ⡦ܤǤϡɥ⤫ɥ⤬Ŭ */
		result[2] = DOCOMO;
		calc_r(tm, tm2, &(result[12]), &(ntc[36]), &(stdt[12]), px);
	} else {
		result[2] = -1;
		calc_r(tm, tm2, &(result[12]), &(ntc[48]), &(stdt[16]), px);
	}

	/* ø */
	calc_r(tm, tm2, &(result[16]), &(ntc[48]), &(stdt[16]), px);

	return;
} /* end of this func */

static void nt_calc(long tm, int tm2, long *r, short *ntc, 
float *dummy0, int *dummy1)
{
	int i;

	r[0] = ntc[0];
	r[1] = ntc[1];
	r[2] = ntc[2];
	r[3] = ntc[3];

	if (tm + tm2 <= 60) return;

	r[0] += ntc[4];
	r[1] += ntc[5];
	r[2] += ntc[6];
	r[3] += ntc[7];

	if (tm + tm2 <= 120) return;

	for (i=0; i<4; i++) {
	r[i] += ntc[i+8] * (1 + ((tm + tm2) - 121) / 60);
	}

	return;
} /* end of this func */

static void std_calc(long tm, int tm2, long *r, short *dummy0, 
float *stdt, int *px)
{
	common_std_calc(tm, tm2, r, stdt, px);
	return;
} /* end of this func */

