/* IDO.c 19990529 19990807 20000703 */
const long ido_revision = 20000703;
/* 19990401	ʥHICAPѻ */
/* 19990414	CdmaOne */

#include <stdio.h>
#include "k_defs.h"
#include "keitai.h"
#include "k_priv.h"

/* ץȥ */
static void ido_komi_calc(long tm, int tm2, long *r, 
float *stdt, int *px); /* 顼Ʊ̾ؿȤȤۤʤ */

/* ܸ */
static const int ido_rinsetu[] = {
	/* (http) */
	fukusima, niigata, toyama, isikawa, fukui, siga, kyoto,
	nara, wakayama, -1 };

/* ץΥǡ */
/* cdmaOne */
static const char *ido_cdma_p[] = {
	"ߥOneե",
	"ߥOneӥͥ",
	"ߥOne",
	"ߥOneΥߡ",
	"ߥOne饤",
	"ǥץ",
	NULL,
};

static const int ido_cdma_info[][2] = {
	32000,	27000,	/* ե */
	12500,	8400,	/* ӥͥ */
	7500,	4500,	/*  */
	3980,	2000,	/* Υߡ */
	3480,	600,	/* 饤 */
	4000,	0,	/* ǥ */
};

static int ido_cdma_px[][5] = {
	/* ݶ, (ݶñ)ʿ, ʿ, ,  */
	/* ݶ3ΤȤݶñ(), ݶñ(), ʲߡ */
	3,	10,	40,	-1,	-1, /* ե */
	3,	10,	30,	-1,	-1,	/* ӥͥ */
	3,	10, 20, -1, -1, /*  */
	3,	10, 15, -1, -1, /* Υߡ */
	3,	10, 10, -1, -1, /* 饤 */
	1,	10, 10, 10, 10, /* ǥ */
};

static float ido_cdma_time[][6][4] = {
/*	Ʊƻܸ
	⡦ܸ
	¾
	(IDO顼)
	
	PHS
ν */
/*	ʿ  ʿ     */
	/* ǥץ(ʿ֤Τ30/10, ۤ1010 */
	30.0,	10.0,	10.0,	10.0,
	30.0,	10.0,	10.0,	10.0,
	30.0,	10.0,	10.0,	10.0,
	30.0,	10.0,	10.0,	10.0,
	30.0,	10.0,	10.0,	10.0,
	30.0,	10.0,	10.0,	10.0,
};

/* PDC, TACS */
static const char *ido_p[] = {
	"Ƥץ(ɸ)",
	"ץ(쥯I)",
	"դץ(쥯II)",
	"",
	"ߥߥץS",
	"ߥߥץL",
	"ߥߥץLL",
	NULL
};

static const char *ido_analog_p[] = {
	"Ƥץ(ɸ)",
	"ץ(쥯I)",
	"դץ(쥯II)",
	"",
	NULL
};

static int ido_px[][5] = {
	/* ݶ, (ݶñ)ʿ, ʿ, ,  */
	/* ݶ3ΤȤݶñ(), ݶñ(), ʲߡ */
	0,	10,	10,	10,	10, /* Ƥ(ɸ) */
	0,	15,	15,	15,	15, /* (쥯1) */
	0,	16,	10,	10,	10, /* դ(쥯2) */
	3,	100,	30,	-1,	-1, /*  */
	3,	10,	15,	-1,	-1,	/* ߥߥץ */
	3,	10,	20,	-1,	-1, /* ߥߥץ */
	3,	10,	25,	-1,	-1, /* ߥߥץ̣ */
	0,	25,	25,	25,	25,	/* IDO_PLAN_SP_STDx25 ͹񥻥顼ץ */
	0,	24,	24,	24,	24,	/* IDO_PLAN_SP_STDx24 쥻顼B.B.ץ */
	0,	14,	10,	10,	10,	/* IDO_PLAN_SP_CHOTTO 顼ƼҤΤäȥ(cdmaOneޤ) */
};

static const int ido_info[][2] = {
	4600, 0,	/* Ƥ(ɸ) */
	3500, 0,	/* (쥯1) */
	3400, 0,	/* դ(쥯2) */
	2000, 0,	/*  */
	3700, 1200,	/* ߥߥץ */
	5700, 2700,	/* ߥߥץ */
	8700, 4800,	/* ߥߥץ̣ */
};

static const int ido_analog_info[][2] = {
	4600, 0,	/* Ƥ(ɸ) */
	3500, 0,	/* (쥯1) */
	3600, 0,	/* դ(쥯2) */
	2000, 0,	/*  */
};

static const int ido_roam2docomo[][2] = {
	/* бɥΥץ, ۴ */
	DO_PDC8_PLAN_A, 270, /* ɸ */
	DO_PDC8_PLAN_B, 210, /* 쥯1 */
	DO_PDC8_PLAN_B, 210, /* 쥯2 */
	DO_PDC8_PLAN_B, 210, /*  */
	DO_PDC8_PLAN_B, 210, /* ߥߥץS  ??? */
	DO_PDC8_PLAN_A, 270, /* ߥߥץL ??? */
	DO_PDC8_PLAN_A, 270, /* ߥߥץLL ??? */
};

static const int ido_roam2ct[] = {
	/* б륻顼Υץ */
	CT_PLAN_STD, /* ɸ */
	CT_PLAN_CHOTTO, /* 쥯1 */
	CT_PLAN_CHOTTO, /* 쥯2 */
	CT_PLAN_SP_IZA, /*  */
	-1, /* ߥߥץϥ顼ߥ󥰤ǤƱ */
	-1,
	-1,
};

static float ido_time[][6][4] = {
/*	Ʊƻܸ
	⡦ܸ
	¾
	(IDO顼)
	
	PHS
ν */
/*	ʿ  ʿ     */
	/* ɸץ(Ƥ) */
	18.0,	28.5,	31.0,	42.5,
	16.0,	25.0,	27.5,	37.5,
	12.0,	20.0,	20.0,	27.5,
	16.0,	26.5,	29.0,	40.0,
	16.0,	26.5,	29.0,	40.0,
	12.0,	20.0,	20.0,	20.0,
	/* 쥯2(դ) */
	18.0,	60.0,	60.0,	60.0,
	16.0,	50.0,	50.0,	50.0,
	12.0,	40.0,	40.0,	40.0,
	16.0,	60.0,	60.0,	60.0,
	16.0,	50.0,	50.0,	50.0,
	12.0,	25.0,	25.0,	25.0,
};

static float ido_analog_time[][6][4] = {
/*	Ʊƻܸ
	⡦ܸ
	¾
	
	(IDO顼)
	PHS
ν */
/*	ʿ  ʿ     */
	/* ɸץ */
	18,	28.5,	31,	42.5,
	16,	25,	27.5,	37.5,
	12,	20,	20,	27.5,
	16,	26.5,	29,	40,
	16,	26.5,	29,	40,
	12,	20.0,	20.0,	20.0,
	/* 쥯2 */
	18,	33,	33,	45.5,
	16,	28.5,	28.5,	39,
	12,	25,	25,	34,
	16,	30,	30,	40,
	16,	30,	30,	40,
	12,	22.5,	22.5,	22.5
};

const char **ido_ls_plan(int i, int d)
{
	switch (d) {
	case TACS:
		return &(ido_analog_p[0]);
	case PDC8:
		return &(ido_p[0]);
	case CDMAONE:
		return &(ido_cdma_p[0]);
	}
	return NULL;
} /* end of func */

const int *ido_getinfo_plan(int i, int d, int plan)
{
	switch (d) {
	case TACS:
		return &(ido_analog_info[plan][0]);
	case PDC8:
		return &(ido_info[plan][0]);
	case CDMAONE:
		return &(ido_cdma_info[plan][0]);
	}
	return NULL;
} /* end of func */

void ido_calc_charge(long *result, long tm, int tm2, int h_ken, 
int t_ken, int ca, int denpa, int plan, int roam_c)
{
	int h;
	int r_ar = 0; /* or */
	int *px = NULL;
	float *stdt = NULL;
	int roam_plan;
	void (*calc_r)(long, int, long *, float *, int *);

	/*  */
	const int *p;
	int j;

	p = ls_carrier_ken(h_ken);
	do {
		h = *p++;
		if (h < 0) break;
	} while (h != IDO);
	/*  h IDO or -1 ˤʤ */

	result[1] = 0;   /* ե饰ν */

	if (h < 0) { /* ߥ */
		if (groupof_carrier(roam_c) == DOCOMO) {
			switch(denpa) {
			case PDC8:
				roam_plan = ido_roam2docomo[plan][0];
				docomo_calc_charge(result, tm, tm2, h_ken, t_ken,
					roam_c, denpa, roam_plan, -1);
				result[3] = ido_roam2docomo[plan][1]; /* ۴ */
				if (plan == IDO_PLAN_KOMI_L || plan == IDO_PLAN_KOMI_S) {
					/* ߥߥץΥɥߥ */
					result[1] |= 0x04; /* ̵ʬ˴ޤޤʤ */
				}
				return;
			default:
			/* 顼 */
				result[0] = 2;
				return;
			}
		}
		if (groupof_carrier(roam_c) == CELLULAR) {
			switch (denpa) {
			case CDMAONE:
				h = IDO; /* cdmaOneϤ٤ƥ顼ǤƱ(Ȼפʤ) */
				break;
			default:
				roam_plan = ido_roam2ct[plan];
				if (roam_plan >= 0) {
					cellular_calc_charge(result, tm, tm2, h_ken,
						t_ken, roam_c, denpa, roam_plan, -1);
					return;
				} else { /* ߥߥץϥߥ󥰤ǤƱ */
					h = IDO;
				} /* if (roam...) */
				break;
			} /* switch */
		} /* if (gr...) */
	} /* if (h) */

	p = ls_system(h);
	do {
		j = *p++;
		if (j < 0) {
			result[0] = 2; /* 顼 */
			result[7] = 0;
			return;
		}
	} while (j != denpa);

	/* 忮Ķȶ⡦ܤǤ뤫ɤå */
	r_ar = is_kuikinai_rinsetu(h, t_ken, &(ido_rinsetu[0]));

	result[7] = 16;  /* Ŀ */

	switch (denpa) {
	case PDC8:
		if (plan == IDO_PLAN_SEL2) {
			stdt = &(ido_time[1][0][0]);
		} else stdt = &(ido_time[0][0][0]);
		px = &(ido_px[plan][0]);
		break;
	case TACS:
		if (plan == IDO_PLAN_SEL2) {
			stdt = &(ido_analog_time[1][0][0]);
		} else stdt = &(ido_analog_time[0][0][0]);
		px = &(ido_px[plan][0]);
		break;
	case CDMAONE:
		px = &(ido_cdma_px[plan][0]);
		stdt = &(ido_cdma_time[0][0][0]);
		break;
	default:
		/* ˤϤʤ */
		break;
	}

	if (px[0] == 3) { /* ߥor */
		calc_r = ido_komi_calc;
	} else { /* ¾Υץ */
		calc_r = common_std_calc;
	}

	/* PHS */
	calc_r(tm, tm2, &(result[20]), &(stdt[20]), px);

	/* ̲ø */
	if (h_ken == t_ken) { /* Ʊƻܸ */
		calc_r(tm, tm2, &(result[8]), &(stdt[0]), px);
	} else if (r_ar > 0) { /* ⡦ */
		calc_r(tm, tm2, &(result[8]), &(stdt[4]), px);
	} else { /* ¾θ */
		calc_r(tm, tm2, &(result[8]), &(stdt[8]), px);
	}

	/* IDOIDOؤγ */
	if (r_ar > 0) {
		calc_r(tm, tm2, &(result[12]), &(stdt[12]), px);
	} else {
		result[2] = -1;
		calc_r(tm, tm2, &(result[12]), &(stdt[12]), px);
	}

	/* ø */
	calc_r(tm, tm2, &(result[16]), &(stdt[16]), px);

	return;
} /* end of this func */

static void ido_komi_calc(long tm, int tm2, long *r, 
float *stdt, int *px)
{
	int i;
	int st, sc;

	st = px[2]; /* std time */
	sc = px[1]; /* std charge */

	r[0] = sc;
	r[1] = sc;
	r[2] = sc;
	r[3] = sc;
	if (tm + tm2 <= st) return;

	for (i=0; i<4; i++) {
	r[i] += sc * (1 + ((tm + tm2) - st -1) / st);
	}
	return;

} /* end of this func */
