/* kmat_tbl.c 19990102 19990606 19990807 19991206 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "k_defs.h"
#include "keitai.h"
#include "cmnfnc.h"
#include "cgi_com.h"

#define SPC_TD ""
#define SPC_TH ""

/* Хѿ */
extern const char *td_str[12];
static int table_begun = 0;

/* ¾ΥեƤؿ */
extern int td_to_t4(int tx, int td, int wd);
long *calc_result(long *ch, int a, int h_kinkyori);
int checkarea_astel(int tken);

/* externʴؿ */
void kmat_html_tbl_print_main(long tm, int tm2, int eken, int hken, int tken,
 int td, int wd, const char *cstr, int h_kinkyori);
void kmat_html_tbl_print_main2(long tm, int tm2, int hken, int tken,
 int td, int wd, int ca, int h_kinkyori);

/* ̤δؿץȥ */
static void print_plan(const char *p, int ca, int denpa, int plan);
static void print_charge(long *ch, int td, int wd, int tken, int h_kinkyori);
static void print_dst(void);
static void print_dst_info(void);

static void begin_table(void);
static void end_table(void);
static void notice_print(const char *p, int mode, long *ch);

void kmat_html_tbl_print_main(long tm, int tm2, int eken, int hken, int tken,
 int td, int wd, const char *cstr, int h_kinkyori)
{
	int i;
	long min, tmx;
	const int *clist;
	int ca;

	clist = ls_carrier_ken(eken);

	/* ǽηޤʸɽ */
	my_printf("%sǱĶȤƤ\n", cstr);

	my_printf("<ul>\n");
	for (i=0; clist[i] >= 0 ; i++) {
		my_printf("<li>");
		my_printf("%s\n", nameof_carrier(clist[i]));
	}
	my_printf("</ul>\n");

	my_printf("ˤĤơ");
	my_printf("<b>%s%s</b>",
		wd ? "()" : "ʿ()", 
		td_str[td]);

	my_printf("<b>%s</b><b>%s</b>",nameof_pref(hken), nameof_pref(tken));
	if (hken == hokkaido && tken == hokkaido) {
		if (h_kinkyori) my_printf("<b>Υ</b>");
		else my_printf("<b>(Υʳ)</b>");
	}
	my_printf("ؤȤ\n");

	my_printf("<b>");
	min = tm / 60;
	tmx = tm - min * 60;
	if (min >= 1) my_printf("%ldʬ", min);
	if (tmx + tm2 > 0) my_printf("%ld%s", tmx, tm2 ? ".5" : "");
	if (min >= 1) my_printf("(%ld%s)", tm, tm2 ? ".5" : "");
	my_printf("</b>");
	my_printf("֤ɽޤ<b>(ñ:)</b><br>\n");

	/* ᥤξɽ */
	for (i=0; ; i++) {
		ca = clist[i];
		if (ca < 0) break;
		kmat_html_tbl_print_main2(tm, tm2, hken, tken, td, wd, ca, h_kinkyori);
	}

	/* Ǹηޤʸɽ */
	my_printf("\n");
	print_dst_info();
	my_printf("<br>\n");
	print_notice_html();

	return;
} /* end of func */

void kmat_html_tbl_print_main2(long tm, int tm2, int hken, int tken,
 int td, int wd, int ca, int h_kinkyori)
{
	int j, k, r;
	int roam_c, ca2;
	const int *dlist;
	const int *rlist;
	const char **plist;
	long *ch;

	r = -1;
	rlist = roaming_carrier(ca, hken);
	do {
		r++;
		my_printf("\n");
		roam_c = rlist[r];
		my_printf("<h3>%s", nameof_carrier(ca));
		if (roam_c >= 0) {
			dlist = ls_system_roaming(ca, roam_c);
			my_printf(" : %s˥ߥ", nameof_carrier(roam_c));
		} else {
			dlist = ls_system(ca);
			ca2 = carrier_group_ken(groupof_carrier(ca), hken);
			if (ca != ca2) {
				my_printf(" ( -&gt; %s)", nameof_carrier(ca2));
			}
		} /* if (roam_c) */
		my_printf("</h3>\n");

		for (j=0; dlist[j] >= 0; j++) {
			my_printf("<b>%s</b><br>\n", nameof_system(dlist[j]));
			begin_table();
			plist = ls_plan(ca, dlist[j]);
			for (k=0; plist[k] != NULL; k++) {
				ch = calc_charge(tm, tm2, hken, tken, ca, 
					dlist[j], k, roam_c);
				if (ch[0] == 1) {
					end_table();
					my_printf("<b>ĶȥꥢǤ</b><br>\n");
					break; /* for */
				}
				print_plan(plist[k], ca, dlist[j], k);
				print_charge(ch, td, wd, tken, h_kinkyori);
			} /* for(k) */
			end_table();
		} /* for(j) */
	} while (roam_c >= 0 && rlist[r+1] >= 0);

	return;
} /* end of func */

/* ɽϤδؿ  */
static void begin_table(void)
{
	table_begun = 1;

	my_printf(
		"<table border=\"1\">\n"
		"<tr><th nowrap rowspan=\"2\">ץ̾</th>\n"
		);

	if (is_print_kihon()) {
		my_printf(
			"<th nowrap rowspan=\"2\">ܻ<br>(̵ʬ)</th>"
			);
	}
	my_printf(
		SPC_TH "\n"
		"<th nowrap colspan=\"7\"></th>"
		"<th nowrap rowspan=\"2\"></th></tr>\n"
		);

	my_printf("<tr>" SPC_TH); /* ޤ򳫤뤿 */
	print_dst();
	my_printf("</tr>\n");

	return;
} /* end of func */

static void end_table(void)
{
	if (table_begun) {
		my_printf("</table>\n");
		notice_print(NULL, 9, NULL);
		my_printf("<br>\n\n");
		table_begun = 0;
	}
	return;
} /* end of func */

static void print_plan(const char *p, int ca, int denpa, int plan)
{
	const int *a;

	a = getinfo_plan(ca, denpa, plan);

	my_printf("<tr>");
	my_printf("<td>%s</td>", p);

	if (is_print_kihon()) {
		my_printf("<td align=\"right\"> %d", a[0]);
		if (a[1] > 0) my_printf(" (%d)", a[1]);
		my_printf(" </td>\n");
	}
	return;
} /* end of func */

static void print_charge(long *ch, int td, int wd, int tken, int h_kinkyori)
{
	int a, i;
	long *r;

	a = td_to_t4(ch[4], td, wd);
	r = calc_result(ch, a, h_kinkyori);

	my_printf(SPC_TD);
	for (i = 0; i <= 1; i++) {
		my_printf("<td align=\"right\"> %ld </td>", r[i]);
	}

	if (checkarea_astel(tken)) /* 忮Ϥ¸֥ƥΥꥢ */
		my_printf("<td align=\"right\"> %ld </td>", r[2]);
	else
		my_printf("<td align=\"right\"> --- </td>");

	for (i = 3; i < 7; i++) {
		my_printf("<td align=\"right\"> %ld </td>", r[i]);
	}

	my_printf("<td>");
	notice_print(NULL, 0, ch);
	my_printf("</tr>\n");

	return;
} /* end of func */

static void print_dst(void)
{
	my_printf("<th nowrap> NTT </th>");
	my_printf("<th nowrap> PHS_U </th>");
	my_printf("<th nowrap> PHS_I </th>");
	my_printf("<th nowrap> DOCOMO </th>");
	my_printf("<th nowrap> CELLULAR <br> IDO </th>");
	my_printf("<th nowrap> JPHONE <br> DIGITU_J </th>");
	my_printf("<th nowrap> TUKA <br> DIGITU_T </th>");

	return;
} /* end of func */

static void print_dst_info(void)
{
	my_printf("<h3></h3>\n"
		"  <b>NTT</b>:      ̲<br>\n"
		"  <b>PHS_U</b>:    DDIݥåȳƼ, NTTɥƼҤPHS,\n"
		"            ƥ񡦶彣<br>\n"
		"  <b>PHS_I</b>:    ƥ̳ƻ̡͹<br>\n"
		"  <b>DOCOMO</b>:   NTTɥη<br>\n"
		"  <b>CELLULAR</b>: 顼Ƽ<br>\n"
		"  <b>IDO</b>:      IDO(ܰư̿)<br>\n"
		"  <b>JPHONE</b>:   ե쳤(ǥۥƼ)<br>\n"
		"  <b>DIGITU_J</b>: ե̳ƻ̡Φ񡦻͹񡦶彣\n"
		"            (ǥġƼ)Τߥ󥰥롼פ\n"
		"            J-եͥåȥεξ<br>\n"
		"  <b>TUKA</b>:     ġ顼쳤, ġۥ<br>\n"
		"  <b>DIGITU_T</b>: ե̳ƻ̡Φ񡦻͹񡦶彣\n"
		"            (ǥġƼ)Τߥ󥰥롼פ\n"
		"            ġͥåȥεξ<br>\n"
		);

	return;
} /* end of func */

static void notice_print(const char *p, int mode, long *ch)
{
#define MAX_NOTICE	15
	static int notice_no = 0;
	static char nstr[MAX_NOTICE][80];
	static int last_added_notice = 0;
	static int pflag_a = 0;

	int i;
	int thistime_printed = 0;

	switch(mode) {
	case -1:
		notice_no -= last_added_notice;
	case 0:
		last_added_notice = 0;

		if (p != NULL) {
			my_printf("%s", p);
			thistime_printed = 1;
		}

		if ((ch[1] & 0x4) != 0) { /* ̵ʬ˴ޤޤʤ */
			my_printf(" *A");
			pflag_a = 1;
			thistime_printed = 1;
		}
		if (ch[3] != 0) { /* ۴(IDO顼Υɥߥ) */
			my_printf(" *%d", notice_no + 1);
			sprintf(&nstr[notice_no][0],
				"۴%ldߤɬס", ch[3]);
			notice_no +=1;
			last_added_notice +=1;
			thistime_printed = 1;
		}

		if (thistime_printed == 0) {
			my_printf("&nbsp;");
		}

		my_printf("</td></tr>\n");
		break;
	case 9:
		if (pflag_a) {
			my_printf("*A ϡ"
				"ܻߤ̵ʬ˴ޤޤޤ<br>\n");
		}
		for (i=0; i < notice_no; i++) {
			my_printf("*%d %s<br>\n", i+1, &nstr[i][0]);
		} /* for(i) */

		/* ѿν */
		notice_no = 0;
		last_added_notice = 0;
		pflag_a = 0;
		break;
	} /* switch(mode) */

	return;
} /* end of thid func */
