/* cmnfnc.c 19990808 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "k_defs.h"
#include "keitai.h"
#include "cmnfnc.h"

/* ХʥХѿ */
int global_print_kihon = 1;

const char *wstr[] = {
		"", /* ߡ */
		"̲",
		"",
		"PHS"
};

const char *chiiki_str[] = {
		"̳ƻ",
		"",
		"㸩",
		"졦ÿϰ",
		"Φ",
		"",
		"",
		"",
		"͹",
		"彣",
		"츩"
};

/* ¾ */
int chiiki2eken(int chiiki)
{
	static const int c2ken[] = {
		hokkaido, aomori, niigata, tokyo, toyama, aichi, osaka,
		tottori, kagawa, fukuoka, okinawa
	};

	return c2ken[chiiki];
} /* end of func */

void double2tm(double f, long *tm, int *tm2)
{
	*tm = (long)f;
	*tm2 = 0;
	f = f - *tm;
	if (f > 0.5) *tm += 1; else if (f > 0) *tm2 = 1;

	return;
} /* end of func */

int checkrange_tm(long tm, int tm2)
{
	if (tm + tm2 > 31622400L) return 99; /* 60*60*24*366 */
	if (tm < 0 || (tm == 0 && tm2 < 0)) return 1;
	if (tm2 != 0 && tm2 != 1) return 2;

	return 0; /*  */
} /* end of func */

int checkrange_ken(int a, int b, int c)
{
	if (a < 0 || a > 46) return 1;
	if (b < 0 || b > 46) return 1;
	if (c < 0 || c > 46) return 1;

	return 0; /*  */
} /* end of func */

int checkrange_chiiki(int chiiki)
{
	if (chiiki < 0 || chiiki > 10) return 7;

	return 0; /*  */
} /* end of func */

void print_notice_html(void)
{
	my_printf("<h3></h3>\n");
	my_printf("  *ˤӾǤޤ<br>\n");
	my_printf("  *ƼҤȤ͡ʳӥѰդƤꡢѤ⤬¤ʤ\n"
		"ޤѤʤɽƤޤ<br>\n");
	my_printf("<br>\n");
	my_printf("  *ΤݤĤ褦ϤƤޤְ㤤Τʬ¸ߤǽ\n"
		"ޤξ硢ŦƤȹǤ<br>\n");
	my_printf("  *ξ̵ݾڤǤ<br>\n");
	my_printf("  *ξλѡѡžܤϼͳǤǤˤƹԤäƤ<br>\n");
} /* end of func */

void print_notice_csv(void)
{
	my_printf("# *ˤӾǤޤ\n");
	my_printf("# *ƼҤȤ͡ʳӥѰդƤꡢѤ⤬¤ʤ\n"
		"# ޤѤʤɽƤޤ\n");
	my_printf("#\n");
	my_printf("# *ΤݤĤ褦ϤƤޤְ㤤Τʬ¸ߤǽ\n"
		"# ޤξ硢ŦƤȹǤ\n");
	my_printf("# *ξ̵ݾڤǤ\n");
	my_printf("# *ξλѡѡžܤϼͳǤǤˤƹԤäƤ\n");
} /* end of func */

void print_notice_txt(void)
{
	my_printf("  *ˤӾǤޤ\n");
	my_printf("  *ƼҤȤ͡ʳӥѰդƤꡢѤ⤬¤ʤ\n"
		"ޤѤʤɽƤޤ\n");
	my_printf("\n");
	my_printf("  *ΤݤĤ褦ϤƤޤְ㤤Τʬ¸ߤǽ\n"
		"ޤξ硢ŦƤȹǤ\n");
	my_printf("  *ξ̵ݾڤǤ\n");
	my_printf("  *ξλѡѡžܤϼͳǤǤˤƹԤäƤ\n");
} /* end of func */

