/* keit_csv.c 19990105 19990606 19990808 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "k_defs.h"
#include "keitai.h"
#include "cmnfnc.h"

static int time_printed = -1;

/* ⻲Ȥؿ */
void keit_csv_print_main(long tm, int tm2, int eken, int hken, int tken,
int w, const char *cstr);
void keit_csv_print_main2(long tm, int tm2, int hken, int tken,
int w, int ca);

/* ؿץȥ */
static void print_p_charge(const char *p, int ca, int denpa, int plan
, long *ch, int w);
static void print_plan(const char *p, int ca, int denpa, int plan);
static void print_tm(int x);
static void print_r4(long c0, long c1, long c2, long c3);
static void print_r2(long c0, long c1);
static void print_ch(long c0, long c1, long c2, long c3);


/* ɽ ᥤ */
void keit_csv_print_main(long tm, int tm2, int eken, int hken, int tken,
int w, const char *cstr)
{
	int i;
	long min, tmx;
	const int *clist;
	int ca;

	time_printed = -1; /* ɬӶʬɽ */
	clist = ls_carrier_ken(eken);

	/* ǽηޤʸɽ */

	my_printf("# %sǱĶȤƤ\n", cstr);

	for (i=0; clist[i] >= 0 ; i++) {
		my_printf("#       %s\n", nameof_carrier(clist[i]));
	}
	my_printf("# ˤĤơ");
	my_printf("%s%s%sؤ",
		nameof_pref(hken), nameof_pref(tken), wstr[w]);

	min = tm / 60;
	tmx = tm - min * 60;
	if (min >= 1) my_printf("%ldʬ", min);
	if (tmx + tm2 > 0) my_printf("%ld%s", tmx, tm2 ? ".5" : "");
	if (min >= 1) my_printf("(%ld%s)", tm, tm2 ? ".5" : "");
	my_printf("֤\n# ɽޤ(ñ:)\n");

	my_printf("#\n");
	my_printf("# ä˻꤬ʤ硢ʿ֤ʿ8:00-19:00, "
			"ʿ֤ʿ19:00-23:00,\n"
			"# ˡ֤(8:00-23:00), "
			"23:00-8:00\n"
			"# ؤޤ\n");

	/* ᥤξɽ */
	for (i=0; ; i++) {
		ca = clist[i];
		if (ca < 0) break;
		keit_csv_print_main2(tm, tm2, hken, tken, w, ca);
	}

	/* Ǹηޤʸɽ */
	my_printf("\n");
	print_notice_csv();

	return;
} /* end of csv_print_main() */

void keit_csv_print_main2(long tm, int tm2, int hken, int tken,
int w, int ca)
{
	int j, k, r;
	int roam_c, ca2;
	const int *dlist;
	const int *rlist;
	const char **plist;
	long *ch;

	r = -1;
	rlist = roaming_carrier(ca, hken);
	do {
		r++;
		my_printf("\n");
		roam_c = rlist[r];
		/* time_printed = -1; */ /* ɬӤɽ */
		my_printf("# %s", nameof_carrier(ca));
		if (roam_c >= 0) {
			dlist = ls_system_roaming(ca, roam_c);
			my_printf(" : %s˥ߥ\n", nameof_carrier(roam_c));
		} else {
			dlist = ls_system(ca);
			ca2 = carrier_group_ken(groupof_carrier(ca), hken);
			if (ca != ca2) {
				my_printf(" ( -> %s)\n", nameof_carrier(ca2));
			} else {
				my_printf("\n");
			}
		} /* if (roam_c) */
		for (j=0; dlist[j] >= 0; j++) {
			my_printf("# < %s >\n", nameof_system(dlist[j]));
			time_printed = -1; /* ɬӤɽ */
			plist = ls_plan(ca, dlist[j]);
			if (plist == NULL) {
				my_printf("(ǡ۾)\n");
			} else {
				for (k=0; plist[k] != NULL; k++) {
					ch = calc_charge(tm, tm2, hken, tken, ca, 
						dlist[j], k, roam_c);
					if (ch[0] == 1) {
						my_printf("# ĶȥꥢǤ\n");
						break; /* for */
					}
					print_p_charge(plist[k], ca, dlist[j], k, ch, w);
				} /* for(k) */
			} /* if(plist) */
		} /* for(j) */
	} while (roam_c >= 0 && rlist[r+1] >= 0);

	return;
} /* end of csv_print_main2() */

/* ɽϤδؿ  */
static void print_p_charge(const char *p, int ca, int denpa, int plan
, long *ch, int w)
{
	int repeat = 0;

	print_tm(ch[4]);

	do {
	/* ++++++++++----------++++++++++----------++++++++++ */
	switch(w) {
	case 1: /* ̲ */
		if (ch[1] & 0x8) { /* ɥ̳ƻΥ¸ */
			if (repeat == 0) {
				print_plan(p, ca, denpa, plan);
				print_ch(ch[32], ch[33], ch[34], ch[35]);
				my_printf("Υ,");
				repeat = 1;
			} else {
				print_plan(p, ca, denpa, plan);
				print_ch(ch[8], ch[9], ch[10], ch[11]);
				my_printf("ʳ,");
				repeat = 0;
			} /* if (repeat == 0) */
		} else {
			print_plan(p, ca, denpa, plan);
			print_ch(ch[8], ch[9], ch[10], ch[11]);
			my_printf(",");
		}
		break;
	case 2: /*  */
		if (ch[2] >= 0) {
			if (repeat == 0) {
				print_plan(p, ca, denpa, plan);
				print_ch(ch[12], ch[13], ch[14], ch[15]);
				my_printf("%sη,", nameof_group(ch[2]));
				repeat = 1;
			} else {
				print_plan(p, ca, denpa, plan);
				print_ch(ch[16], ch[17], ch[18], ch[19]);
				my_printf("ʳ,");
				repeat = 0;
			} /* if (repeat == 0) */
		} else {
			print_plan(p, ca, denpa, plan);
			print_ch(ch[16], ch[17], ch[18], ch[19]);
			my_printf(",");
		}
		break;
	case 3: /* PHS */
		if ((ch[1] & 0x1)== 1) {
			if (repeat == 0) {
				print_plan(p, ca, denpa, plan);
				print_ch(ch[20], ch[21], ch[22], ch[23]);
				my_printf("¸PHS,");
				repeat = 1;
			} else {
				print_plan(p, ca, denpa, plan);
				print_ch(ch[24], ch[25], ch[26], ch[27]);
				my_printf("ȼPHS,");
				repeat = 0;
			} /* if (repeat == 0) */
		} else {
			print_plan(p, ca, denpa, plan);
			print_ch(ch[20], ch[21], ch[22], ch[23]);
			my_printf(",");
		}
		break;
	} /* switch(w) */

	if ((ch[1] & 0x4) != 0) { /* ̵ʬ˴ޤޤʤ */
		my_printf("̵ä˴ޤޤʤ");
	}

	if (ch[3] != 0) { /* ۴(IDO顼Υɥߥ) */
		my_printf("۴%ldߤɬס", ch[3]);
	}

	my_printf("\n");
	/* ++++++++++----------++++++++++----------++++++++++ */
	} while(repeat);

	return;
} /* end of thid func */

static void print_plan(const char *p, int ca, int denpa, int plan)
{
	const int *a;

	a = getinfo_plan(ca, denpa, plan);

	my_printf("%s,", p);

	if (is_print_kihon()) {
		my_printf("%d,", a[0]);
		/* if (a[1] > 0) */ my_printf("%d,", a[1]);
	}

	return;
} /* end of func */

static void print_tm(int x)
{
	static const char *tmstr[] = {
	/* ɸ */
		"ʿ,ʿ,,,",
	/* TIME_N1 */
		"ʿ8:00-17:00,ʿ17:00-19:00,"
		"8:00-19:00,19:00-8:00,",
	/* TIME_N2 */
		"ӥͥ(ʿ9:00-11:30,13:30-17:00),"
		"ޥ(ʳ),,,",
	/* TIME_N3 */
		"ʿ8:00-11:30+13:30-23:00,ʳ,,,",
	/* TIME_N4 */
		"ʿ7:00-21:00,7:00-21:00,"
		"21:00-0:00,0:00-7:00,",
	/* TIME_N5 */
		"8:00-22:00,22:00-8:00,,,",
	/* TIME_N6 */
		"ʿ9:00-17:00,ʳ,,,",
	/* TIME_N7 */
		"ʿ8:00-11:30+13:30-23:00,ʿ11:30-13:30,"
		"8:00--23:00,23:00-8:00,",
	/* TIME_N8 */
		"8:00-20:00,20:00-8:00,,,",
	/* TIME_N9 */
		"8:00-17:00,17:00-8:00,,,",
	/* ñʤߡ */
		NULL
	};

	if (time_printed == x) return;

	my_printf("##ץ̾,");
	if (is_print_kihon()) my_printf("ܻ,̵,");

	my_printf("%s", tmstr[x]);
	my_printf(",\n");

	time_printed = x;
	return;
} /* end of func */

static void print_r4(long c0, long c1, long c2, long c3)
{
	my_printf("%ld,%ld,%ld,%ld,",
				c0, c1, c2, c3);

	return;
} /* end of func */

static void print_r2(long c0, long c1)
{
	my_printf("%ld,%ld,,,", c0, c1);
	return;
} /* end of func */

static void print_ch(long c0, long c1, long c2, long c3)
{
	switch(time_printed) {
	case TIME_STD:
	case TIME_N1:
		print_r4(c0, c1, c2, c3);
		break;
	case TIME_N2:
		print_r2(c0, c1);
		break;
	case TIME_N3:
		print_r2(c0, c2);
		break;
	case TIME_N4:
		print_r4(c0, c2, c1, c3);
		break;
	case TIME_N5:
	case TIME_N8:
	case TIME_N9:
		print_r2(c0, c3);
		break;
	case TIME_N6:
		print_r2(c0, c1);
		break;
	case TIME_N7:
		print_r4(c0, c1, c2, c3);
		break;
	}

	return;
} /* end of func */
