/* keit_tbl.c 19990102 19990606 19990723 19990807 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "k_defs.h"
#include "keitai.h"
#include "cmnfnc.h"
#include "cgi_com.h"

#define SPC_TD ""
#define SPC_TH ""

/* externʴؿ */
void keit_html_tbl_print_main(long tm, int tm2, int eken, int hken, int tken,
int w, const char *cstr);
void keit_html_tbl_print_main2(long tm, int tm2, int hken, int tken,
int w, int ca);

static int time_printed = -1;
static int table_begun = 0;

/* ̤δؿץȥ */
static void begin_table(void);
static void end_table(void);
static void print_plan_charge(const char *p, int ca, int denpa, int plan,
long *ch, int w);
static void notice_print(const char *p, int mode, long *ch);
static void print_plan_tm(int row, const char *p, int ca, int denpa,
int plan, int x);
static void print_tm(int x);
static void print_r4(long c0, long c1, long c2, long c3);
static void print_r3_1(long c0, long c1);
static void print_r2_2(long c0, long c1);
static void print_ch(long c0, long c1, long c2, long c3);

void keit_html_tbl_print_main2(long tm, int tm2, int hken, int tken,
int w, int ca)
{
	int j, k, r;
	int roam_c, ca2;
	const int *dlist;
	const int *rlist;
	const char **plist;
	long *ch;

	r = -1;
	rlist = roaming_carrier(ca, hken);
	do {
		r++;
		my_printf("\n");
		roam_c = rlist[r];
		my_printf("<h3>%s", nameof_carrier(ca));
		if (roam_c >= 0) {
			dlist = ls_system_roaming(ca, roam_c);
			my_printf(" : %s˥ߥ", nameof_carrier(roam_c));
		} else {
			dlist = ls_system(ca);
			ca2 = carrier_group_ken(groupof_carrier(ca), hken);
			if (ca != ca2) {
				my_printf(" ( -&gt; %s)", nameof_carrier(ca2));
			}
		} /* if (roam_c) */
		my_printf("</h3>\n");

		for (j=0; dlist[j] >= 0; j++) {
			my_printf("<b>%s</b></br>\n", nameof_system(dlist[j]));
			plist = ls_plan(ca, dlist[j]);
			if (plist == NULL) {
				my_printf("(ǡ۾)<br>\n");
			} else {
				begin_table();
				for (k=0; plist[k] != NULL; k++) {
					ch = calc_charge(tm, tm2, hken, tken, ca, 
						dlist[j], k, roam_c);
					if (ch[0] == 1) {
						end_table();
						my_printf("<b>ĶȥꥢǤ</b></br>\n");
						break; /* for */
					}
					print_plan_charge(plist[k], ca, dlist[j], k, ch, w);
				} /* for(k) */
				end_table();
			} /* if(plist) */
		} /* for(j) */
	} while (roam_c >= 0 && rlist[r+1] >= 0);

	return;
} /* end of func */

/* ɽϤδؿ  */
static void begin_table(void)
{
	table_begun = 1;

	my_printf(
		"<table border=\"1\">\n"
		"<tr><th nowrap rowspan=\"2\">ץ̾</th>\n"
		);

	if (is_print_kihon()) {
		my_printf(
			"<th nowrap rowspan=\"2\">ܻ<br>(̵ʬ)</th>"
			);
	}
	my_printf(
		SPC_TH "\n" /* ޤ򳫤뤿 */
		"<th nowrap colspan=\"4\"></th>\n"
		"<th nowrap rowspan=\"2\"></th></tr>\n"
		"<tr>"
		);

	my_printf(SPC_TH "\n"); /* ޤ򳫤뤿 */
	print_tm(TIME_STD);
	my_printf("</tr>\n");
	time_printed = TIME_STD;
	return;
} /* end of func */

static void end_table(void)
{
	if (table_begun) {
		my_printf("</table>\n");
		notice_print(NULL, 9, NULL);
		my_printf("<br>\n\n");
		table_begun = 0;
	}
	return;
} /* end of func */

static void print_plan_charge(const char *p, int ca, int denpa, int plan,
long *ch, int w)
{
	switch(w) {
	case 1: /* ̲ */
		if (ch[1] & 0x8) { /* ɥ̳ƻΥ¸ */
			print_plan_tm(2, p, ca, denpa, plan, ch[4]);
			print_ch(ch[32], ch[33], ch[34], ch[35]);
			notice_print("<td>Υ", 0, ch);
			my_printf("<tr>" SPC_TD);
			print_ch(ch[8], ch[9], ch[10], ch[11]);
			notice_print("<td>ʳ", -1, ch);
		} else {
			print_plan_tm(1, p, ca, denpa, plan, ch[4]);
			print_ch(ch[8], ch[9], ch[10], ch[11]);
			my_printf("<td>");
			notice_print(NULL, 0, ch);
		}
		break;
	case 2: /*  */
		if (ch[2] >= 0) {
			print_plan_tm(2, p, ca, denpa, plan, ch[4]);
			print_ch(ch[12], ch[13], ch[14], ch[15]);
			my_printf("<td>%s", nameof_group(ch[2]));
			notice_print("η", 0, ch);
			my_printf("<tr>" SPC_TD);
			print_ch(ch[16], ch[17], ch[18], ch[19]);
			notice_print("<td>ʳ", -1, ch);
		} else {
			print_plan_tm(1, p, ca, denpa, plan, ch[4]);
			print_ch(ch[16], ch[17], ch[18], ch[19]);
			my_printf("<td>");
			notice_print(NULL, 0, ch);
		}
		break;
	case 3: /* PHS */
		if ((ch[1] & 0x1)== 1) {
			print_plan_tm(2, p, ca, denpa, plan, ch[4]);
			print_ch(ch[20], ch[21], ch[22], ch[23]);
			notice_print("<td>¸PHS", 0, ch);
			my_printf("<tr>" SPC_TD);
			print_ch(ch[24], ch[25], ch[26], ch[27]);
			notice_print("<td>ȼPHS", -1, ch);
		} else {
			print_plan_tm(1, p, ca, denpa, plan, ch[4]);
			print_ch(ch[20], ch[21], ch[22], ch[23]);
			my_printf("<td>");
			notice_print(NULL, 0, ch);
		}
		break;
	} /* switch(w) */

	return;
} /* end of thid func */

static void notice_print(const char *p, int mode, long *ch)
{
#define MAX_NOTICE	15
	static int notice_no = 0;
	static char nstr[MAX_NOTICE][80];
	static int last_added_notice = 0;
	static int pflag_a = 0;

	int i;
	int thistime_printed = 0;

	switch(mode) {
	case -1:
		notice_no -= last_added_notice;
	case 0:
		last_added_notice = 0;

		if (p != NULL) {
			my_printf("%s", p);
			thistime_printed = 1;
		}

		if ((ch[1] & 0x4) != 0) { /* ̵ʬ˴ޤޤʤ */
			my_printf(" *A");
			pflag_a = 1;
			thistime_printed = 1;
		}
		if (ch[3] != 0) { /* ۴(IDO顼Υɥߥ) */
			my_printf(" *%d", notice_no + 1);
			sprintf(&nstr[notice_no][0],
				"۴%ldߤɬס", ch[3]);
			notice_no +=1;
			last_added_notice +=1;
			thistime_printed = 1;
		}

		if (thistime_printed == 0) {
			my_printf("&nbsp;");
		}

		my_printf("</td></tr>\n");
		break;
	case 9:
		if (pflag_a) {
			my_printf("*A ϡ"
				"ܻߤ̵ʬ˴ޤޤޤ<br>\n");
		}
		for (i=0; i < notice_no; i++) {
			my_printf("*%d %s<br>\n", i+1, &nstr[i][0]);
		} /* for(i) */

		/* ѿν */
		notice_no = 0;
		last_added_notice = 0;
		pflag_a = 0;
		break;
	} /* switch(mode) */

	return;
} /* end of thid func */

static void print_plan_tm(int row, const char *p, int ca, int denpa,
int plan, int x)
{
	const int *a;

	a = getinfo_plan(ca, denpa, plan);

	if (time_printed != x) row += 1;

	my_printf("<tr><td rowspan=\"%d\">", row);
	my_printf("%s</td>", p);

	if (is_print_kihon()) {
		my_printf("<td rowspan=\"%d\" align=\"right\">", row);
		my_printf(" %d ", a[0]);
		if (a[1] > 0) my_printf("(%d) ", a[1]);
		my_printf("</td>");
	}

		my_printf(SPC_TD "\n"); /* ޤ򳫤뤿 */

	if (time_printed != x) {
		print_tm(x);
		time_printed = x;
		my_printf("<th>&nbsp;</th></tr>\n"); /* ͡ */
		my_printf("<tr>" SPC_TD); /* ιԤΤ */
	}

	return;

} /* end of thid func */

static void print_tm(int x)
{
	static const char *tmstr[] = {
	/* ɸ */
		"<th nowrap> ʿ </th>"
		"<th nowrap> ʿ </th>"
		"<th nowrap>  </th>" /* ѥڡ */
		"<th nowrap> 롡 </th>" /* ѥڡ */
		"",
	/* TIME_N1 */
		"<th nowrap> ʿ8:00<br>-17:00 </th>"
		"<th nowrap> ʿ17:00<br>-19:00 </th>"
		"<th nowrap> 8:00<br>-19:00 </th>"
		"<th nowrap> 19:00<br>-8:00 </th>" /* ѥڡ */
		"",
	/* TIME_N2 */
		"<th nowrap colspan=\"2\"> ӥͥ<br>"
		"(ʿ9:00-11:30,13:30-17:00) </th>"
		"<th nowrap colspan=\"2\"> ޥ<br>(ʳ) </th>"
		"",
	/* TIME_N3 */
		"<th nowrap colspan=\"2\"> ʿ8:00-11:30,<br>13:30-23:00 </th>"
		"<th nowrap colspan=\"2\"> ʳ </th>"
		"",
	/* TIME_N4 */
		"<th nowrap> ʿ7:00<br>-21:00 </th>"
		"<th nowrap> 7:00<br>-21:00 </th>"
		"<th nowrap> 21:00<br>-0:00 </th>"
		"<th nowrap> 0:00<br>-7:00 </th>"
		"",
	/* TIME_N5 */
		"<th nowrap colspan=\"2\"> 8:00-22:00 </th>"
		"<th nowrap colspan=\"2\"> 22:00-8:00 </th>"
		"",
	/* TIME_N6 */
		"<th nowrap colspan=\"2\"> ʿ9:00-17:00 </th>"
		"<th nowrap colspan=\"2\"> ʳ </th>"
		"",
	/* TIME_N7 */
		"<th nowrap> ʿ8:00-11:30<br>13:30-23:00 </th>"
		"<th nowrap> ʿ11:30<br>-13:30 </th>"
		"<th nowrap> 8:00<br>-23:00 </th>"
		"<th nowrap> 23:00<br>-8:00 </th>"
		"",
	/* TIME_N8 */
		"<th nowrap colspan=\"2\"> 8:00-20:00 </th>"
		"<th nowrap colspan=\"2\"> 20:00-8:00 </th>"
		"",
	/* TIME_N9 */
		"<th nowrap colspan=\"2\"> 8:00-17:00 </th>"
		"<th nowrap colspan=\"2\"> 17:00-8:00 </th>"
		"",
	/* ñʤߡ */
		NULL
	};

	my_printf("%s", tmstr[x]);

	return;
} /* end of func */

static void print_r4(long c0, long c1, long c2, long c3)
{
	my_printf(
		"<td align=\"right\"> %ld </td>"
		"<td align=\"right\"> %ld </td>"
		"<td align=\"right\"> %ld </td>"
		"<td align=\"right\"> %ld </td>"
		,c0, c1, c2, c3);

	return;
} /* end of func */

#if 0 /* ȤꤢѤʤ */
static void print_r3_1(long c0, long c1)
{
	my_printf(
		"<td align=\"right\" colspan=\"3\"> %ld </td>"
		"<td align=\"right\"> %ld </td>"
		,c0, c1);

} /* end of func */
#endif

static void print_r2_2(long c0, long c1)
{
	my_printf(
		"<td align=\"right\" colspan=\"2\"> %ld </td>"
		"<td align=\"right\" colspan=\"2\"> %ld </td>"
		,c0, c1);

} /* end of func */

static void print_ch(long c0, long c1, long c2, long c3)
{
	switch(time_printed) {
	case TIME_STD:
	case TIME_N1:
		print_r4(c0, c1, c2, c3);
		break;
	case TIME_N2:
		/* print_r3_1(c0, c1); */
		print_r2_2(c0, c1);
		break;
	case TIME_N3:
		/* print_r3_1(c0, c2); */
		print_r2_2(c0, c2);
		break;
	case TIME_N4:
		print_r4(c0, c2, c1, c3);
		break;
	case TIME_N5:
	case TIME_N8:
	case TIME_N9:
		print_r2_2(c0, c3);
		break;
	case TIME_N6:
		print_r2_2(c0, c1);
		break;
	case TIME_N7:
		print_r4(c0, c1, c2, c3);
		break;
	}

	return;
} /* end of func */

void keit_html_tbl_print_main(long tm, int tm2, int eken, int hken, int tken,
int w, const char *cstr)
{
	int i;
	long min, tmx;
	const int *clist;
	int ca;

	clist = ls_carrier_ken(eken);

	/* ǽηޤʸɽ */

	my_printf("%sǱĶȤƤ\n", cstr);

	my_printf("<ul>\n");
	for (i=0; clist[i] >= 0 ; i++) {
		my_printf("<li>");
		my_printf("%s\n", nameof_carrier(clist[i]));
	}
	my_printf("</ul>\n");

	my_printf("ˤĤơ");
	my_printf("<b>%s</b>", nameof_pref(hken));
	my_printf("<b>%s</b>", nameof_pref(tken));
	my_printf("<b>%s</b>ؤ", wstr[w]);

	my_printf("<b>");
	min = tm / 60;
	tmx = tm - min * 60;
	if (min >= 1) my_printf("%ldʬ", min);
	if (tmx + tm2 > 0) my_printf("%ld%s", tmx, tm2 ? ".5" : "");
	if (min >= 1) my_printf("(%ld%s)", tm, tm2 ? ".5" : "");
	my_printf("</b>");
	my_printf("֤ɽޤ<b>(ñ:)</b>\n");

	my_printf("<br><br>\n");
	my_printf("ä˻꤬ʤ硢"
			"<b>ʿ</b>ʿ8:00-19:00, "
			"<b>ʿ</b>ʿ19:00-23:00,\n"
			"<b></b>ˡ֤(8:00-23:00), "
			"<b></b>23:00-8:00\n"
			"ؤޤ<br>\n");

	/* ᥤξɽ */
	for (i=0; ; i++) {
		ca = clist[i];
		if (ca < 0) break;
		keit_html_tbl_print_main2(tm, tm2, hken, tken, w, ca);
	}

	/* Ǹηޤʸɽ */
	print_notice_html();

	return;
} /* end of func */
