/* kmat_csv.c 19990105 19990606 19990808 19991206 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "k_defs.h"
#include "keitai.h"
#include "cmnfnc.h"

/* Хѿ */
extern const char *td_str[12];

/* ¾ΥեƤؿ */
extern int td_to_t4(int tx, int td, int wd);
long *calc_result(long *ch, int a, int h_kinkyori);
int checkarea_astel(int tken);

/* externʴؿ */
void kmat_csv_print_main(long tm, int tm2, int eken, int hken, int tken,
 int td, int wd, const char *cstr, int h_kinkyori);
void kmat_csv_print_main2(long tm, int tm2, int hken, int tken,
 int td, int wd, int ca, int h_kinkyori);

/* ̤δؿץȥ */
static void print_plan(const char *p, int ca, int denpa, int plan,
int roam_c);
static void print_charge(long *ch, int td, int wd, int tken, int h_kinkyori);
static void print_dst(void);
static void print_dst_info(void);


/* ɽᥤ */
void kmat_csv_print_main(long tm, int tm2, int eken, int hken, int tken,
 int td, int wd, const char *cstr, int h_kinkyori)
{
	int i;
	long min, tmx;
	const int *clist;
	int ca;

	clist = ls_carrier_ken(eken);

	/* ǽηޤʸɽ */
	my_printf("# %sǱĶȤƤ\n", cstr);

	for (i=0; clist[i] >= 0 ; i++) {
		my_printf("#        %s\n", nameof_carrier(clist[i]));
	}
	my_printf("# ˤĤơ");
	my_printf("%s%s",
		wd ? "()" : "ʿ()", 
		td_str[td]);

	my_printf("%s%s",nameof_pref(hken), nameof_pref(tken));
	if (hken == hokkaido && tken == hokkaido) {
		if (h_kinkyori) my_printf("ζΥ");
		else my_printf("(Υʳ)");
	}
	my_printf("ؤȤ\n");

	my_printf("# ");
	min = tm / 60;
	tmx = tm - min * 60;
	if (min >= 1) my_printf("%ldʬ", min);
	if (tmx + tm2 > 0) my_printf("%ld%s", tmx, tm2 ? ".5" : "");
	if (min >= 1) my_printf("(%ld%s)", tm, tm2 ? ".5" : "");
	my_printf("֤ɽޤ(ñ:)\n");

	/* ᥤξɽ */
	for (i=0; ; i++) {
		ca = clist[i];
		if (ca < 0) break;
		kmat_csv_print_main2(tm, tm2, hken, tken, td, wd, ca, h_kinkyori);
	}

	/* Ǹηޤʸɽ */
	my_printf("\n");
	print_dst_info();
	my_printf("#\n");
	print_notice_csv();

	return;
} /* end of func */

void kmat_csv_print_main2(long tm, int tm2, int hken, int tken,
 int td, int wd, int ca, int h_kinkyori)
{
	int j, k, r;
	int roam_c, ca2;
	const int *dlist;
	const int *rlist;
	const char **plist;
	long *ch;

	r = -1;
	rlist = roaming_carrier(ca, hken);
	do {
		r++;
		my_printf("\n");
		roam_c = rlist[r];
		my_printf("# %s", nameof_carrier(ca));
		if (roam_c >= 0) {
			dlist = ls_system_roaming(ca, roam_c);
			my_printf(" : %s˥ߥ\n", nameof_carrier(roam_c));
		} else {
			dlist = ls_system(ca);
			ca2 = carrier_group_ken(groupof_carrier(ca), hken);
			if (ca != ca2) {
				my_printf(" ( -> %s)\n", nameof_carrier(ca2));
			} else {
				my_printf("\n");
			}
		} /* if (roam_c) */

		for (j=0; dlist[j] >= 0; j++) {
			my_printf("# < %s >\n", nameof_system(dlist[j]));
			print_dst(); /* ɽ */
			plist = ls_plan(ca, dlist[j]);
			for (k=0; plist[k] != NULL; k++) {
				ch = calc_charge(tm, tm2, hken, tken, ca, 
					dlist[j], k, roam_c);
				if (ch[0] == 1) {
					my_printf( "# ĶȥꥢǤ\n");
					break; /* for */
				}
				print_plan(plist[k], ca, dlist[j], k, roam_c);
				print_charge(ch, td, wd, tken, h_kinkyori);
			} /* for(k) */
		} /* for(j) */
	} while (roam_c >= 0 && rlist[r+1] >= 0);

	return;
} /* end of func */

/* ɽϤδؿ  */
static void print_plan(const char *p, int ca, int denpa, int plan,
int roam_c)
{
	const int *a;

	a = getinfo_plan(ca, denpa, plan);

	my_printf("%s,", nameof_carrier(ca)); /* ̾ */
	my_printf("%s,", nameof_system(denpa)); /* ȷ */

#if 0
	if (roam_c >= 0) { /* ߥ */
		my_printf("%s,", nameof_carrier(roam_c));
	} else {
		my_printf(",");
	}
#endif /* 0 */

	my_printf("%s,", p); /* ץ̾ */

	if (is_print_kihon()) {
		my_printf("%d,", a[0]);
		/* if (a[1] > 0) */ my_printf("%d,", a[1]);
	}

	return;
} /* end of func */

static void print_charge(long *ch, int td, int wd, int tken,
 int h_kinkyori)
{
	int a, i;
	long *r;

	a = td_to_t4(ch[4], td, wd);
	r = calc_result(ch, a, h_kinkyori);

	for (i = 0; i <= 1 ; i++) {
		my_printf("%ld,", r[i]);
	}

	if (checkarea_astel(tken)) /* 忮Ϥ¸֥ƥΥꥢ */
		my_printf("%ld,", r[2]);
	else
		my_printf("%s,", "");

	for (i = 3; i < 7; i++) {
		my_printf("%ld,", r[i]);
	}


	if ((ch[1] & 0x4) != 0) { /* ̵ʬ˴ޤޤʤ */
		my_printf(
				"̵ä˴ޤޤʤ");
	}

	if (ch[3] != 0) { /* ۴(IDO顼Υɥߥ) */
		my_printf("۴%ldߤɬס", ch[3]);
	}
	my_printf("\n");
	return;
} /* end of func */

static void print_dst(void)
{
	my_printf("##");
	my_printf("̾,ȷ,");
	/* my_printf("ߥ,"); */
	my_printf("ץ̾,");

	if (is_print_kihon()) my_printf("ܻ, ̵,");

	my_printf("NTT,"
			"PHS_U,"
			"PHS_I,"
			"DOCOMO,"
			"CELLULAR+IDO,"
			"JPHONE+DIGITU_J,"
			"TUKA+DIGITU_T,");

	my_printf("\n");

	return;
} /* end of func */

static void print_dst_info(void)
{
	my_printf("# \n"
		"#  NTT:      ̲\n"
		"#  PHS_U:    DDIݥåȳƼ, NTTɥƼҤPHS,\n"
		"#            ƥ񡦶彣\n"
		"#  PHS_I:    ƥ̳ƻ̡͹\n"
		"#  DOCOMO:   NTTɥη\n"
		"#  CELLULAR: 顼Ƽ\n"
		"#  IDO:      IDO(ܰư̿)\n"
		"#  JPHONE:   ե쳤(ǥۥƼ)\n"
		"#  DIGITU_J: ե̳ƻ̡Φ񡦻͹񡦶彣\n"
		"#            (ǥġƼ)Τߥ󥰥롼פ\n"
		"#            J-եͥåȥεξ\n"
		"#  TUKA:     ġ顼쳤, ġۥ\n"
		"#  DIGITU_T: ե̳ƻ̡Φ񡦻͹񡦶彣\n"
		"#            (ǥġƼ)Τߥ󥰥롼פ\n"
		"#            ġͥåȥεξ\n"
		);

	return;
} /* end of func */
